% Parametricky zpusob pocitani druhe derivace
clear all    
load data.flt
%data=sortrows(data,1) ;
x=data(:,1);
y=data(:,2);
%x=x(1:1000) ;
%y=y(1:1000) ;
t=1:length(x) ;
clear data ;


%approximujeme splinem
degy=7 ; % stupen splinu pro aproximaci y(t)
ndery=4 ; % stupen derivace kterou minimizujeme pro aproximaci y(t)
degx=3 ; % stupen splinu pro aproximaci x(t)
nderx=2 ; % stupen derivace kterou minimizujeme pro aproximaci x(t)

Ny=50 ;% kolik koeficientu pro y(t)
Nx=50 ;% kolik koeficientu pro y(t) % 100 taky neni spatne
lambday=1 ; % regularizace pro y(t) 
lambdax=30 ; % regularizace pro x(t) ;
Np=300 ; % v kolika bodech vyhodnocujeme

[cx,Tx,dx]=lsrsplnapr(t,x,Nx,degx,lambdax,nderx) ;
[cy,Ty,dy]=lsrsplnapr(t,y,Ny,degy,lambday,ndery) ;

tt=linspace(min(t),max(t),Np) ; % v techto bodech vyhodnocujeme
figure(1) ;
subplot(211) ;
xx=evalmbspline(tt,cx,Tx,dx,degx) ;
plot(t,x,'.',tt,xx,'r') ; legend('Measured','Smoothed') ; title('x') ;
subplot(212) ;
yy=evalmbspline(tt,cy,Ty,dy,degy) ;
plot(t,y,'.',tt,yy,'r') ; legend('Measured','Smoothed') ; title('y') ;

% Pocitame derivace
cderx=conv(cx,[1 -1])/Tx ;
cdery=conv(cy,[1 -1])/Ty ;
cdderx=conv(cx,[1 -2 1])/Tx^2 ;
cdderx=cdderx(2:length(cdderx)-1) ; 
cddery=conv(cy,[1 -2 1])/Ty^2 ;
cddery=cddery(2:length(cddery)-1) ; 

xxd=evalmbspline(tt,cderx,Tx,dx+0.5,degx-1) ; % shifted by half a step
xxdd=evalmbspline(tt,cdderx,Tx,dx,degx-2) ;
yyd=evalmbspline(tt,cdery,Ty,dy+0.5,degy-1) ; % shifted by half a step
yydd=evalmbspline(tt,cddery,Ty,dy,degy-2) ;


figure(2) ;
subplot(411) ; plot(tt,xxd) ; title('dt/dx') ;
subplot(412) ; plot(tt,xxdd) ; title('d2t/dx2') ;
subplot(413) ; plot(tt,yyd) ; title('dy/dt') ;
subplot(414) ; plot(tt,yydd) ; title('d2y/dt2') ;

figure(3) ;
yyxx=yydd./(xxd.^2)-yyd.*xxdd./(xxd.^3) ; % d^2 y/d x^2 v bodech x
plot(xx,yyxx) ;
title('Second derivative d2y/dx2') ; xlabel('x') ; ylabel('y''''') ;


