function y=imhpfilter(f,x)
% Given an image x, highpass filter it with a cutoff-frequency f
% and normalize to the 0-1 range
%
% Usage: y=imhpfilter(f,x)

[f1,f2] = freqspace(21,'meshgrid');
Hd = ones(size(f1));
dist = sqrt(f1.^2 + f2.^2);
Hd((dist<f))=0 ;
h=fsamp2(Hd) ;
y=filter2(h,x) ;
miny=min(min(y)) ; maxy=max(max(y)) ;
y=(y-miny)/(-miny+maxy) ;

 