function y=evalcbint(x,c,t,deg) ;
% evaluate interpolation with abs(x)^deg in 1D at points t
% the interpolation is described by weights c and points x 
%
% Jan Kybic, February 2000
%
% $Id: evalcbint.m,v 1.1 2000/02/02 17:00:30 jkybic Exp $

if nargin==3, deg=3 ; end ;

m=length(t) ;
if deg==3,
  n=length(c)-2 ;
  y=zeros(m,1) ;
  for i=1:m, % for all points
    y(i)=c(n+2)+c(n+1)*t(i)+c(1:n)'*abs(x-t(i)).^deg ;
  end ;
elseif deg==4,
  n=length(c)-2 ;
  y=zeros(m,1) ;
  for i=1:m, % for all points
    y(i)=c(n+2)+c(n+1)*t(i); 
    r=abs(x-t(i)) ;
    ri=find(r==0) ; r(ri)=1 ; rs=log(r) ; rs(ri)=0 ;
    y(i)=y(i)+c(1:n)'*(r.^4.*rs) ;
  end ;
  
else 
  
  error('unsupported deg') ;
end ;
