function sum=filtcoefper(x) 
% find coefficients c for interpolation with periodized
% unidimensional rbf
%
% Jan Kybic, January 2000
%
% $Id: filtcoefper.m,v 1.1 2000/01/31 17:48:49 jkybic Exp $
% 

N=length(x) ;

if floor(N/2)~=N/2-0.5,
  error('Signal length should be odd') ;
end ;

y=1:N ;
for k=1:N,
  y(k)=persf((k-floor(N/2)-1)/N) ;
end ;

plot(y,'x') ;

r=roots(y) ;
r=sort(r) ;
r=r(1:(N-1)/2) ; % find stable roots

% filter
c=filiirs(x,r,1) 
a=mean(x) ;

% check
t=(0:N-1)/N ;
for k=1:N,
  y(k)=evalper(t,c,t)+a ;
end ;
plot(t,y,t,x) ; legend('interp','wanted') ;



function y=evalper(x,c,t) ;
m=length(t) ;
n=length(c)-1 ;
y=zeros(m,1) ;
for i=1:m, % for all points
  y(i)=c(n+1) ;
  for k=1:n , % for all generating functions
    y(i)=y(i)+c(k)*persf(x(k)-t(i)) ;
  end ;
end ;

function y=persf(x) ;
y=0 ;
x=x*2*pi ;
for k=1:10, % how many terms to consider
  y=y+cos(k*x)/k^4 ;
%  y=y+cos(k*x)*(sin(k)/(k))^2 ;
end ;
