function c=fourcoefper(x) 
% find coefficients c for interpolation with periodized
% unidimensional rbf in Fourier domain
% the control points are assumed to be (0:N-1)/N
%
% Jan Kybic, January 2000
%
% $Id: fourcoefper.m,v 1.2 2000/02/02 17:00:30 jkybic Exp $
% 

x=x(:) ;
N=length(x) ;

t=(0:N-1)/N ;

y=1:N ; % calculate kernel
fy=zeros(N,1) ;
for k=1:N-1,
%  y(k)=persf(t(k)) ;
   fy(k+1)=N*(1/k^4+1/(k+N)^4+1/(k-N)^4+1/(k+2*N)^4+1/(k-2*N)^4) ;
end ;

%figure(1) ;
%plot(y,'x') ;
%fy=fft(y) ;

c=zeros(1,N+1) ;
xt=x ;

for iter=1:1,
  fx=fft(xt) ;
  fc=[ 0 ; fx(2:N)./fy(2:N)] ;
  ct=real(ifft(fc)) ; 
  a=mean(xt) ; c=c+[ct' a] ;
  yt=evalper(t,c,t) ;
  xt=x-yt ; % sum(xt.^2)
end ;

if 0,
figure(2) ;
ydf=fft(xt)  ;
semilogy(2:N,abs(fx(2:N)),2:N,fy(2:N),2:N,abs(fx(2:N)./fy(2:N)),...,
    2:N,abs(ydf(2:N))) ; 
legend('input','filt','result','difference') ;
title('Fourier analysis') ;
figure(3) ;
plot(t,x,t,yt) ; legend('wanted','calculated') ;
end ;
