function c=getcoefcb(x,y,deg) ;
% find coefficients for interpolation with abs(x)^deg in 1D
%
% deg should be 3 or 4
%
% Jan Kybic, February 2000
%
% $Id: getcoefcb.m,v 1.1 2000/02/02 17:00:30 jkybic Exp $

x=x(:) ; y=y(:) ;

if nargin==2, deg=3 ; end ;

n=length(x) ;
if deg==3,
  A=zeros(n+2) ;

  for i=1:n, % generate the system matrix
    for j=1:n,
      A(i,j)=abs(x(i)-x(j))^deg ; 
    end ;
    A(i,n+1:n+2)=[ x(i) 1 ] ; 
  end ;
  
  A(n+1,1:n)=x(:)' ;
  A(n+2,1:n)=ones(1,n) ;
  
  c=A\[y ; 0 ; 0] ;
elseif deg==4,
  A=zeros(n+2) ;

  for i=1:n, % generate the system matrix
    for j=1:n,
      r=abs(x(i)-x(j)) ; 
      if r>0, A(i,j)=r^4*log(r) ; end ;
    end ;
    A(i,n+1:n+2)=[ x(i) 1 ] ; 
  end ;

  A(n+1,1:n)=x' ;
  A(n+2,1:n)=ones(1,n) ;
  
  c=A\[y ; 0 ; 0] ;
  
else
  error('unsupported deg') ;
end ;  