function c=getcoefper(x,y) ;
% find coefficients c for interpolation with periodized
% unidimensional rbf by solving an algebraic system of equations
%
% Jan Kybic, January 2000
%
% $Id: getcoefper.m,v 1.1 2000/02/01 12:25:10 jkybic Exp $
% 

n=length(x) ;
A=zeros(n+1) ;

for i=1:n, % generate the system matrix
  for j=1:n,
    A(i,j)=persf(x(i)-x(j)) ; 
  end ;
  A(i,n+1)=[ 1 ] ; 
end ;

A(n+1,1:n)=ones(1,n) ;
[u,s,v]=svd(A) ;
s=diag(s) ;
q=(s(1)*1e-30+1e-50) ; % the q-value is sensitive !!!
for i=1:n+1,
  if s(i)<q, s(i)=0 ; 
  else s(i)=1/s(i) ; end ;
end ;

c=v*diag(s)*u'*[y(:) ; 0] ;

% r=A*c-[y(:) ;0] ; sum(r.^2) 
% c1=c+A\r ;
% r=A*c1-[y(:) ;0] ; sum(r.^2) 

% keyboard



