function w=lndradeval(p,x,c,alpha) ;
% Evaluate radial power function interpolation at (2D) point p given
% coefficients c 
% and landmark locations x
%
% Usage:  w=lndradeval(p,x,c,alpha) 
%
% $Id: lndradeval.m,v 1.2 1999/10/08 12:24:54 jkybic Exp $
% Jan Kybic, 1999

w=0 ;
n=length(c)-3 ;
alphah=alpha/2 ;

% disp([ 'linear part ' num2str(c(n+1)*p(1)+c(n+2)*p(2)+c(n+3)) ]) ;


for i=1:n,
    r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ;
    if r2>0,
      w=w+c(i)*r2^alphah ; % actually twice as much as r^2 ln(r) 
      % disp([ 'adding ' num2str(r2) ' ' num2str(r2^alphah,9) ' ' num2str(c(i)*r2^alphah,9) ]) ;
  end ;
end ;

w=w+c(n+1)*p(1)+c(n+2)*p(2)+c(n+3) ;

