function w=lndradimg(img,x,z,alpha) ;
% Warp image moving landmarks from points z in img to point x,
% interpolating in-between. Input coordinates expected in 
% Matlab ordering. Using radial power functions.
%
% Usage: w=lndradimg(img,x,z,alpha) ;
%
% Jan Kybic, 1999
%
% $Id: lndradimg.m,v 1.4 1999/10/11 16:40:57 jkybic Exp $

[ny,nx]=size(img) ;
x=[ x(:,2) x(:,1) ]-1 ; % rearrange from Matlab conventions
z=[ z(:,2) z(:,1) ]-1 ;
% disp('Calculating coefficients') ;
cx=lndradcoef(x,z(:,1),alpha) ;
cy=lndradcoef(x,z(:,2),alpha) ;
% disp('Bspline transform') ;
f=fsplinem(img,3) ; 
% disp('Generating table - mex') ;

tabx=mexlndradtbl(x,cx,ny,nx,alpha) ;
taby=mexlndradtbl(x,cy,ny,nx,alpha) ;
ind=find(tabx>ny-1) ; % the roles of x and y are swapped
ind=union(ind,find(tabx<0)) ;
ind=union(ind,find(taby<0)) ;
ind=union(ind,find(taby>nx-1)) ;
tabx(ind)=0 ; taby(ind)=0 ;
tab1=shiftdim( reshape([ tabx taby ],ny,nx,2),2) ;

% tab=zeros(2,ny,nx) ;
% for i=1:nx,
%   for j=1:ny,
%    tab(:,j,i)=[ lndradeval([j i]-1,x,cx,alpha)  lndradeval([j i]-1,x,cy,alpha) ] ; 
%   end ;
% end ;

%tab1(1,1:5,10)
%tab(1,1:5,10)

%format compact
%for i=1:length(x),
%  [ x(i,:) z(i,:) tab1(1:2,x(i,1)+1,x(i,2)+1)' ]
%end ;
%format loose

% disp('Warping') ;  
w=mexsplninterp(f,tab1,2,3) ;
% disp('Finished') ;
