function c=lndthscoefder(x,z) ;
% x has Matlab ordering, i.e. [y x] !
% z=[f df/dx df/dy] or z=[f] (then the derivatives are not taken into account)
%
% evgf evaluates r^4 log(r), therefore the kernel contains
% quadratic polynomials
%
% Jan Kybic, February 2000
%
% $Id: lndthscoefder.m,v 1.2 2000/02/10 14:42:39 jkybic Exp $

[n,nd]=size(z) ;
if nd==3,
  A=zeros(n*3+6) ;
  for i=1:n,   % y
    for j=1:n, % x
      [f,fx,fy,fxx,fxy,fyy]=evgf(x(i,2)-x(j,2),x(i,1)-x(j,1)) ;
      A(i,j)=f ; A(i,j+n)=fx ; A(i,j+2*n)=fy ;
      A(i,3*n+1:3*n+6)=[ x(i,2)^2 x(i,1)^2 x(i,2)*x(i,1) x(i,2) x(i,1) 1 ] ; 
      A(i+n,j)=fx ; A(i+n,j+n)=fxx ; A(i+n,j+2*n)=fxy ;
      A(i+n,3*n+1:3*n+6)=[  2*x(i,2) 0 x(i,1) 1 0 0 ] ;
      A(i+2*n,j)=fy ; A(i+2*n,j+n)=fxy ; A(i+2*n,j+2*n)=fyy ;
      A(i+2*n,3*n+1:3*n+6)=[  0 2*x(i,1) x(i,2) 0 1 0 ] ;
    end ;
  end ;
  A(3*n+1:3*n+6,1:3*n)=A(1:3*n,3*n+1:3*n+6)' ;
  
  rs=[z(:,1) ;z(:,2); z(:,3) ; 0 ; 0 ; 0 ; 0; 0; 0] ;
elseif nd==1,
  A=zeros(n+6) ;
  for i=1:n,   % y
    for j=1:n, % x
      f=evgf(x(i,2)-x(j,2),x(i,1)-x(j,1)) ;
      A(i,j)=f ; 
      A(i,n+1:n+6)=[ x(i,2)^2 x(i,1)^2 x(i,2)*x(i,1) x(i,2) x(i,1) 1 ] ; 
    end ;
  end ;
  A(n+1:n+6,1:n)=A(1:n,n+1:n+6)' ;
  
  rs=[z(:,1) ; 0 ; 0 ; 0 ; 0; 0; 0] ;
  %A(1,:)
  %keyboard

else
  error('incorrect number of columns for z') ;
end ;

% The matrix is set, now solve the set of equation
if 0, % SVD or built-in method for linear equation solving
  [u,s,v]=svd(A) ;
  s=diag(s) ; 
  cnd=s(1)/s(3*n+3) ;
  q=(s(1)*1e-20+1e-50) ; % the q-value is sensitive !!!
  for i=1:3*n+3,
    if s(i)<q, s(i)=0 ; 
    else 
      s(i)=1/s(i) ; 
    end ;
  end ;
    
  c=v*diag(s)*u'*rs ;
else
  c=A\rs ;  
end ;

% res=sum((A*c-rs).^2) 
