function w=lndthseval(p,x,c) ;
% Evaluate a thin-plate spline at (2D) point p given coefficients c
% and landmark locations x
%
% Usage:  w=lndthseval(p,x,c) 
%
% $Id: lndthseval.m,v 1.1 1999/09/17 15:18:15 jkybic Exp $
% Jan Kybic, 1999

w=0 ;
n=length(c)-3 ;

for i=1:n,
    r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ;
    if r2>0,
      w=w+c(i)*r2*log(r2) ; % actually twice as much as r^2 ln(r) 
  end ;
end ;

w=w+c(n+1)*p(1)+c(n+2)*p(2)+c(n+3) ;

