function w=lndthsimg(img,x,z) ;
% Warp image moving landmarks from points z in img to point x,
% interpolating in-between. Input coordinates expected in 
% Matlab ordering
%
% Usage: w=lndthsimg(img,x,z) ;
%
% Jan Kybic, 1999
%
% $Id: lndthsimg.m,v 1.2 1999/10/08 08:59:58 jkybic Exp $

[ny,nx]=size(img) ;
x=[ x(:,2) x(:,1) ]-1 ; % rearrange from Matlab conventions
z=[ z(:,2) z(:,1) ]-1 ;
disp('Calculating coefficients') ;
cx=lndthscoef(x,z(:,1)) ;
cy=lndthscoef(x,z(:,2)) ;
disp('Bspline transform') ;
f=fsplinem(img,3) ; 
disp('Generating table') ;
tab=zeros(2,ny,nx) ;
for i=1:nx,
  for j=1:ny,
    tab(:,j,i)=[ lndthseval([j i],x,cx)  lndthseval([j i],x,cy) ] ; 
  end ;
end ;
disp('Warping') ;  
w=mexsplninterp(f,tab,2,3) ;
disp('Finished') ;
