function w=lndthsimgder(img,x,z) ;
% Warp image using landmark warping with prescribed derivatives
% Deformation function (fx,fy) verifies
% z(i)=[ fx fy dfx/dx dfy/dx dfx/dy dfy/dy](x(i))
%
% Matlab ordering for x, i.e. [y x], starting at 0
%
% Usage: w=lndthsimgder(img,x,z) ;
%
% Jan Kybic, 2000
%
% $Id: lndthsimgder.m,v 1.7 2000/02/10 10:47:36 jkybic Exp $

%if 0,
[ny,nx]=size(img) ;
disp('Calculating coefficients') ;
cx=lndthscoefder(x+1,[ z(:,1) z(:,3) z(:,5)]) ;
cy=lndthscoefder(x+1,[ z(:,2) z(:,4) z(:,6)]) ;

% Check
for i=1:size(x,1),
  disp(sprintf('At x=(%g,%g) z=(%g,%g) result=(%g,%g)',x(i,2)+1,x(i,1)+1, ...
      z(i,1),z(i,2),lndthsdereval(x(i,:)+1,x+1,cx),...
      lndthsdereval(x(i,:)+1,x+1,cy))) ;
end ;


disp('Bspline transform') ;
f=fsplinem(img,3) ; 
disp('Generating table') ;
tab=zeros(2,ny,nx) ;
for i=1:nx,
  for j=1:ny,
    tab(:,j,i)=[ lndthsdereval([j i],x+1,cy)  lndthsdereval([j i],x+1,cx) ] ; 
    % i,j already start at 1
  end ;
end ;
disp('Warping') ;  
w=mexsplninterp(f,tab,2,3) ;
disp('Finished') ;
%end ;

%testing
%x= [ 0 1 ; 1 0 ; 1 1 ; 1 2 ] ;
%z=[ 2 0 0 ; 3 0 0 ; 4 0 0 ; 5 0 0] ;
%c=lndthscoefder(x,z) 
%lndthsdereval(x(1,:),x,c)
%lndthsdereval(x(2,:),x,c)
%lndthsdereval(x(3,:),x,c)






