function sum=rlogrloc(x,y)
% calculate Sum ( exp( 2 pi i (kx+ly)/T) / (16 pi^4 (k^2+l^2)^2) )
% using a localization filter
%
% Jan Kybic, January 2000
%
% $Id: rlogrloc.m,v 1.5 2000/01/26 20:59:44 jkybic Exp $

% set up the localization filter
h=[ -5040+3920*pi^4  2565-1080*pi^4 -540+108*pi^4 45-8*pi^4 ;...
    2565-1080*pi^4   -1080           135           0         ;...
    -540+108*pi^4    135            0             0         ;...
    45-8*pi^4        0              0             0         ] ;
% multiplicative constants:  pi5 / 2 from F. transf, 1/2880pi6 from h,
% 1/2 from rflr
h=h/2/2880/pi/2 ; 

N=3 ; % how many functions to take into account
sum=-1 ;
x=x-floor(x) ;
y=y-floor(y) ;
for i=-N:N,
  for j=-N:N,
   val=psi(x+i,y+j,h)  ;
   sum=sum+val ;
%   disp(['(' num2str(i) ',' num2str(j) ') ' num2str(val)]) ;
 end ;
end ;

sum=sum/16/pi^4 ;

function sum=psi(x,y,h) ;
% calculates the psi function
r2=x*x+y*y ;
% sum=2 pi^3 r^2 log(r)
if r2>0, sum=pi^3*r2*log(r2) ; else sum=0 ; end ;

sum=sum+hrflr(x,y,h)+pi^3*r2 ;

function sum=rflr(x,y)
% Calculates r^4*log(r^2)=2 r^4 log(r)
r2=x*x+y*y ;
if r2>0, sum= r2^2*log(r2) ; else sum=0 ; end ;


function sum=hrflr(x,y,h)
% Calculates h convoluted with rflr
sum=0 ;
if 0,
  for i=-3:3,
    for j=-3:3,
      sum=sum+h(abs(i)+1,abs(j)+1)*rflr(x+i,y+j) ;
    end ;
  end ;
else %  equivalent optimized version...
      sum=h(1,1)*rflr(x,y)...
      +h(2,1)*(rflr(x+1,y)+rflr(x-1,y)+rflr(x,y+1)+rflr(x,y-1))...
      +h(3,1)*(rflr(x+2,y)+rflr(x-2,y)+rflr(x,y+2)+rflr(x,y-2))...
      +h(4,1)*(rflr(x+3,y)+rflr(x-3,y)+rflr(x,y+3)+rflr(x,y-3))...
      +h(2,2)*(rflr(x+1,y+1)+rflr(x-1,y+1)+rflr(x+1,y-1)+rflr(x-1,y-1))...
      +h(2,3)*(rflr(x+1,y+2)+rflr(x-1,y+2)+rflr(x+1,y-2)+rflr(x-1,y-2)+...
               rflr(x+2,y+1)+rflr(x-2,y+1)+rflr(x+2,y-1)+rflr(x-2,y-1)) ;
end ;
   
     