function showfelreglnd() ;
% Shows the result of landmark interpolation with the same landmarks as in
% registerDistantLandmarks in felregexp
%
%
% $Id: showfelreglnd.m,v 1.1 2001/04/29 12:32:59 jkybic Exp $
% Jan Kybic, April 2001

sizx=768; % Matlab convention
sizy=576;

% Load Chus's images
img1=readchusraw('/home/jkybic/people/chus/images/Im-4C-Clip0004-masked/4C-Clip0004-768x576-0_mask.raw',[sizx,sizy]) ;

img2=readchusraw('/home/jkybic/people/chus/images/Im-4C-Clip0004-masked/4C-Clip0004-768x576-10_mask.raw',[sizx,sizy]) ;


% Landmarks in the reference
% (x,y) ordering, origin at upper left corner
z=[  412 409 ; 347 174 ; 306 348 ; 490 324 ]-1 ;

% Landmarks in the test image  

x=[  376 421 ; 371 163 ; 268 261 ; 493 277 ]-1 ;

xm= [ x(:,2)  x(:,1) ]+1 ; % to Matlab ordering (y,x)
zm= [ z(:,2)  z(:,1) ]+1 ;

% add landmarks to images
%img1=addlandmarks(img1,zm) ;
%img2=addlandmarks(img2,xm) ;

% show images
clf ;
figure(1)
subplot(321) ; imagesc(img1) ; colormap(gray) ; axis image ; 
axis off ; title('Reference')
subplot(322) ; imagesc(img2) ; colormap(gray) ; axis image ; 
axis off ; title('Test')
  
%img2=addgrid(img2) ;

w=lndthsimg(img2,z,x) ;

figure(2) ; clf
imagesc(w) ; colormap(gray) ; axis image ; axis off
title('Thin plate splines')

imwrite(w/255.0,'showfelreglnd.tiff','tiff')

function img=readchusraw(fname,expsize) ;
% Read ultrasound images in Chus' raw format
f=fopen(fname) ;
img=fread(f,expsize) ;
fclose(f) ;
img=flipdim(img',1) ;

function img=addlandmarks(img,x) ;
% Add landmarks as small squares
[sizy,sizx]=size(img) ;
szl=7 ; szli=4 ;
for i=1:length(x),
  bx=x(i,2) ; by=x(i,1) ;
  for ix=max(1,bx-szl):min(bx+szl,sizx),
    for iy=max(1,by-szl):min(by+szl,sizy),
      img(iy,ix)=0 ;
    end ;
  end ;
end ;

for i=1:length(x),
  bx=x(i,2) ; by=x(i,1) ;
  for ix=max(1,bx-szli):min(bx+szli,sizx),
    for iy=max(1,by-szli):min(by+szli,sizy),
      img(iy,ix)=255 ;
    end ;
  end ;
end ;

function img=addgrid(img) ;
% add grid to an image
gs=32 ; % grid step
[sizy,sizx]=size(img) ;

for i=floor(gs/2):gs:sizy-floor(gs/2),
  img(i,:)=255*ones(1,sizx) ;
end ;

for i=floor(gs/2):gs:sizx-floor(gs/2),
  img(:,i)=255*ones(sizy,1) ;
end ;
