% script to show interpolation error for periodized and classical interp.
%
%
clear  all ;
sigma=0 ;
% fnc='sin(15*x).^3.*exp(-(x-0.5).^2*10)+sigma*randn(length(x),1)' ;

fnc='sin(2*pi*x*sigma)'

ptsl=[10 15 20 25 30 35 40 60 80 100 500 1000]' ;
%ptsl=[10 15 20]' ;
%sigmal=[0 0.01 0.1 1]' ;
sigmal=[1 2 5 10]' ;
%sigmal=[0]' ;
ptsln=length(ptsl) ;
sigmaln=length(sigmal) ;

rmsc=zeros(sigmaln,ptsln) ; % rms errors
rmsq=zeros(sigmaln,ptsln) ; % rms errors
%rmspf=zeros(sigmaln,ptsln) ; 
rmspa=zeros(sigmaln,ptsln) ; 

for isgm=1:sigmaln,
  sigma=sigmal(isgm) ;
  for ipts=1:ptsln,
    N=ptsl(ipts) 
    x=(0:N-1)'/N ; % sampling points
    y=eval(fnc) ; % function values
    figure(1) ; plot(x,y) ; pause(0.01) ;
    cc=getcoefcb(x,y) ; % classical interpolation
    cq=getcoefcb(x,y,4) ; % classical interpolation
%    cpf=fourcoefper(y) ; % fourier periodic interpolation
    cpa=getcoefper(x,y) ; % fourier periodic interpolation
    yxc=evalcbint(x,cc,x) ; % interpolated value
    yxq=evalcbint(x,cq,x,4) ; % interpolated value
    yxpa=evalper(x,cpa,x) ; % interpolated value
 %   yxpf=evalper(x,cpf,x) ; % interpolated value
    rmsc(isgm,ipts)=sqrt(sum((y-yxc).^2)/N) ;
    rmsq(isgm,ipts)=sqrt(sum((y-yxq).^2)/N) ;
%    rmspf(isgm,ipts)=sqrt(sum((y-yxpa).^2)/N) 
    rmspa(isgm,ipts)=sqrt(sum((y-yxpa).^2)/N) ;
  end ;
end ;

for isgm=1:sigmaln,
  sigma=sigmal(isgm) ;
  figure(isgm) ;
%  semilogy(ptsl,rmsc(isgm,:),'o-',ptsl,rmsq(isgm,:),'x-',...
%      ptsl,rmspf(isgm,:),'+-',ptsl,rmspa(isgm,:),'*-') ;
%  legend('x3','x4logx','per four','per anal') ;
  semilogy(ptsl,rmsc(isgm,:),'o-',ptsl,rmsq(isgm,:),'x-',...
      ptsl,rmspa(isgm,:),'*-') ;
  legend('x3','x4logx','periodic') ;
  title([ 'RMS error pp, sigma=' num2str(sigma)]) ;
  xlabel('points') ; 
  axis([10 100 1e-14 1e2]) ; grid on ;
end ;
