function showlndalphdepimg ;
% Shows the dependence of the warping result for landmark interpolation by
% radial basis functions r^\alpha on \alpha. 
%
% Caution: lndradcoef and friends use the linear terms although they should
% not for noninteger alpha
%
% $Id: showlndalphdepimg.m,v 1.5 2001/04/29 12:32:59 jkybic Exp $
% Jan Kybic, March 2001

%img=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
%pyr=pyramid2(im,3) ; img=normalize(pyr{4}) ;
%save smallbarb img
%load smallbarb
sizx=768; % Matlab convention
sizy=576;

% Load Chus's images
img1=readchusraw('/home/jkybic/people/chus/images/Im-4C-Clip0004-masked/4C-Clip0004-768x576-0_mask.raw',[sizx,sizy]) ;

img2=readchusraw('/home/jkybic/people/chus/images/Im-4C-Clip0004-masked/4C-Clip0004-768x576-10_mask.raw',[sizx,sizy]) ;


% Landmarks in the reference
% (x,y) ordering, origin at upper left corner
%z=[ 10 10 ; 10 566 ; 758 10 ;  758 566 ; ...
% 412 409 ; 396 328 ; 347 174 ; 306 348 ; 523 229 ; 490 324 ]-1 ;
z=[ 10 10 ; 10 566 ; 758 10 ;  758 566 ; ...
 412 409 ; 396 328 ; 347 174 ; 306 348 ; 490 324 ]-1 ;

%z= [ 412 409 ; 396 328 ; 347 174 ; 306 348 ]-1 ;
% Landmarks in the test image  
%x=[  10 10 ; 10 566 ; 758 10 ;  758 566 ; ...
%  376 421 ; 382 284 ; 371 163 ; 268 261 ; 493 277 ; 515 356 ]-1 ;
x=[  10 10 ; 10 566 ; 758 10 ;  758 566 ; ...
  376 421 ; 382 284 ; 371 163 ; 268 261 ; 493 277 ]-1 ;

%x=[  376 421 ; 382 284 ; 371 163 ; 268 261 ]-1 ;

xm= [ x(:,2)  x(:,1) ]+1 ; % to Matlab ordering (y,x)
zm= [ z(:,2)  z(:,1) ]+1 ;

% add landmarks to images
img1=addlandmarks(img1,zm) ;
img2=addlandmarks(img2,xm) ;



% show images
clf ;
subplot(321) ; imagesc(img1) ; colormap(gray) ; axis image ; 
axis off ; title('Reference')
subplot(322) ; imagesc(img2) ; colormap(gray) ; axis image ; 
axis off ; title('Test')
  
img2=addgrid(img2) ;

w=lndradimg(img2,z,x,0.5) ;
%w=addlandmarks(w,zm) ;

subplot(323) ; imagesc(w) ; colormap(gray) ; axis image ; axis off
title('alpha=0.5')
pause(0.01)

w=lndradimg(img2,z,x,0.9) ;
subplot(324) ; imagesc(w) ; colormap(gray) ; axis image ; axis off
title('alpha=0.9')
pause(0.01)

w=lndradimg(img2,z,x,1.3) ;
subplot(325) ; imagesc(w) ; colormap(gray) ; axis image ;axis off
title('alpha=1.3')
pause(0.01)

w=lndradimg(img2,z,x,2.5) ;
subplot(326) ; imagesc(w) ; colormap(gray) ; axis image ; axis off
title('alpha=2.5')
pause(0.01)


print -deps showlndalphdepimg.eps

function img=readchusraw(fname,expsize) ;
% Read ultrasound images in Chus' raw format
f=fopen(fname) ;
img=fread(f,expsize) ;
fclose(f) ;
img=flipdim(img',1) ;

function img=addlandmarks(img,x) ;
% Add landmarks as small squares
[sizy,sizx]=size(img) ;
szl=7 ; szli=4 ;
for i=1:length(x),
  bx=x(i,2) ; by=x(i,1) ;
  for ix=max(1,bx-szl):min(bx+szl,sizx),
    for iy=max(1,by-szl):min(by+szl,sizy),
      img(iy,ix)=0 ;
    end ;
  end ;
end ;

for i=1:length(x),
  bx=x(i,2) ; by=x(i,1) ;
  for ix=max(1,bx-szli):min(bx+szli,sizx),
    for iy=max(1,by-szli):min(by+szli,sizy),
      img(iy,ix)=255 ;
    end ;
  end ;
end ;

function img=addgrid(img) ;
% add grid to an image
gs=32 ; % grid step
[sizy,sizx]=size(img) ;

for i=floor(gs/2):gs:sizy-floor(gs/2),
  img(i,:)=255*ones(1,sizx) ;
end ;

for i=floor(gs/2):gs:sizx-floor(gs/2),
  img(:,i)=255*ones(sizy,1) ;
end ;
