% Show smoothing splines
% $Id: showsmooth.m,v 1.1 2000/09/01 09:50:54 jkybic Exp $

% cubic splines minimising second derivatives in 1D

% Let first define points to interpolate 

x=[ 3 ; 5 ; 6 ; 12 ; 17 ; 23 ] ;
y=[ 1 ; 2 ; 3 ; 6 ; 3 ; 2 ] ;
dy=[ 0 ; 0.2 ; -0.2 ; 0 ; -1 ; 1 ] ;
  
gamma=1e-3 ;

n=length(x) ;

% set up the system of equations
A=zeros(n+2) ;

for i=1:n, % generate the system matrix
  for j=1:n,
    A(i,j)=abs(x(i)-x(j))^3 ; 
  end ;
  A(i,i)=A(i,i)+1/gamma ;
  A(i,n+1:n+2)=[ x(i) 1 ] ; 
end ;



A(n+1,1:n)=x(:)' ;
A(n+2,1:n)=ones(1,n) ;

c=A\[y ; 0 ; 0] ;

% where we evaluate 
tx=1:0.1:25 ;
yx=tx ; % interpolated value

m=length(tx) ;
for i=1:m, % for all points
  yx(i)=c(n+2)+c(n+1)*tx(i)+c(1:n)'*abs(x-tx(i)).^3 ;
end ;

figure(1) ;
plot(tx,yx,'b-',x,y,'ro') ; 
axis([ 0 25 0 7]) ;
print -deps showsmooth-fig1.eps



