function showudper
% Demonstrates unidirectional interpolation
%
% Jan Kybic
%
% $Id: showudper.m,v 1.5 2000/02/02 17:00:31 jkybic Exp $

% Let first define points to interpolate 

% x=rand(20,1) ;
N=25 ;
x=(0:N-1)'/N ;
T=1 ;
x=x/T ; % as per currently works only in 0-1
y=sin(15*x).^3.*exp(-(x-0.5).^2*10)+0.1*randn(length(x),1) ;
  
n=length(x) ;

c=getcoefcb(x,y) ;
cpa=getcoefper(x,y) ;
cpf=fourcoefper(y) ;

% where we evaluate 
tx=0:0.01:1 ; tx=tx/T ; 
yx=evalcbint(x,c,tx) ; % interpolated value
yxpa=evalper(x,cpa,tx) ; % interpolated value
yxpf=evalper(x,cpf,tx) ; % interpolated value
yt=sin(15*tx).^3.*exp(-(tx-0.5).^2*10) ;

if 0,
figure(1) ;
plot(tx,yx,'b-',tx,yxpa,'g-',tx,yxpf,'m-',tx,yt,'r-',x,y,'ro') ; 
legend('Classic','Periodized','PerFour','True','Points') ;
% axis([ 0 25/T 0 7]) ;
end ;

if 0,
  figure(2) ;
  t=-1:0.01:2 ;
  y=t ;
  for k=1:length(t),
    y(k)=persf(t(k)) ;
  end ;
  
  plot(t,y) ; title('Periodized interpolation splines') ;
end ;




