function trylndderimg ;
% Script to try landmark warping of images using derivative information

% Test landmark image warping by lndthsimg

path('/home/jkybic/matlab/mexsol',path) ;
path(path,'/home/jkybic/matlab_repository');
path(path,'/home/jkybic/matlab') ;
path(path,'/home/jkybic/matlab/spline'); 
path(path,'/home/jkybic/matlab/util') ;
path(path,'/home/jkybic/matlab/pyramid'); 
path(path,'/home/jkybic/matlab/imspline') ;

%im=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
%pyr=pyramid2(im,3) ; img=normalize(pyr{4}) ;
%save smallbarb img

imgl=double(imread('/home/jkybic/matlab/images/unser.tiff')) ;
imgr=double(imread('/home/jkybic/matlab/images/blu.tiff')) ;

lnd=load('/home/jkybic/work/idl/lndmarksrad14.1.dat') ; 
[ny,N]=size(lnd) ;
N=N/2 ;
[ny,nx]=size(imgl) ;
lndc=[ 0 0 nx nx ; 0 ny 0 ny] ;
lndl=[lnd(:,1:N) lndc] ; lndr=[lnd(:,N+1:2*N) lndc];
lndl=[lndl(1,:)' lndl(2,:)'] ;
lndr=[lndr(1,:)' lndr(2,:)'] ;
figure(1) ;
subplot(221) ; imagesc(imgl) ; colormap(gray) ; axis image ; axis off ;
drcrosses(lndl) ;
subplot(222) ; imagesc(imgr) ; colormap(gray) ; axis image ; axis off ;
drcrosses(lndr) ;
pause(0.01) ;

if 0,
  cc=cputime ;
  wl=lndthsimg(imgl,lndr,lndl) ;
  wr=lndthsimg(imgr,lndl,lndr) ;
  disp([ 'elapsed ' num2str(cputime-cc) ' s']) ;
  subplot(223) ; imagesc(wl) ; colormap(gray) ; axis image ; axis off
  subplot(224) ; imagesc(wr) ; colormap(gray) ; axis image ; axis off
  save trylndderimgres wl wr
else
  load trylndderimgres
end ;

figure(2) ;
lsraw=load('/home/jkybic/work/idl/regpatchesout.dat') ;
lsatr=zeros(N,5,4) ;
for k=1:N,
  lsatr(k,:,:)=lsraw(k*5-4:k*5,:) ;
end ;
% prepare data for derivative interpolation
ldx=zeros(N+8,2) ;
ldz=zeros(N+8,6) ;

ldx(1:8,:)=[ 0 0 ; ny/2 0 ; ny 0 ; 0 nx ; 0 nx/2 ; ny nx/2 ; nx ny/2 ; ny nx ] ;
% source position (Matlab ordering)
ldz(1:8,1)=ldx(1:8,2) ; ldz(1:8,2)=ldx(1:8,1) ;
ldz(1:8,3:6)=[ ones(8,1) zeros(8,2) ones(8,1) ] ;
% target position (classical ordering); derivatives stay zero

for k=1:N,
  ldx(k+8,:)=[ lsatr(k,1,4) lsatr(k,1,3)] ; % [ y x ] of the landmark
  ldz(k+8,:)=[ lsatr(k,1,3)+lsatr(k,2,4) lsatr(k,1,4)+lsatr(k,3,4) ...
	     lsatr(k,2,1) lsatr(k,3,1) lsatr(k,2,2) lsatr(k,3,2) ] ;
end ;

subplot(221) ; imagesc((wl-imgr)) ; colormap(gray) ; axis image ; axis off
subplot(222) ; imagesc((wr-imgl)) ; colormap(gray) ; axis image ; axis off
subplot(223) ; imagesc((imgl-imgr)) ; colormap(gray) ; axis image ; axis off
subplot(224) ; imagesc((imgr-imgl)) ; colormap(gray) ; axis image ; axis off

if 1,
  cc=cputime ;
  wld=lndthsimgder(imgl,ldx,ldz) ;
  disp([ 'elapsed ' num2str(cputime-cc) ' s']) ;
  save trylndderimgresder wld
else
  load trylndderimgresder
end ;

figure(3) ;
imagesc(wld) ; colormap(gray) ; axis image ; axis off

function drcrosses(lnd) ;
[ny,nx]=size(lnd) ;
for i=1:ny,
  drcross(lnd(i,1),lnd(i,2)) ;
end ;

function drcross(x,y) ;
s=5 ;
h=line([x-s x+s],[y y]) ;
set(h,'color','red') ;
h=line([x x],[y-s y+s]) ;
set(h,'color','red') ;
