% Tries to interpolate with lndpercoef

sigma=0.1 ;
% Random sampling points 
N=100 ;
x=0.5*ones(N,2)+randn(N,2)/5 ;
z=zeros(N,1) ;
for k=1:N,
  r2=(x(k,1)-0.5)^2+(x(k,2)-0.5)^2 ;
  z(k)=exp(-r2/sigma) ;
end ;

figure(1) ;
plot(x(:,1),x(:,2),'*') ; title('sampling points') ;

[xt,yt]=meshgrid(0:0.05:1,0:0.05:1) ;
zt=xt ;
[ny nx]=size(xt) ;
for i=1:nx,
  for j=1:ny,
    zt(j,i)=exp(-((xt(j,i)-0.5)^2+(yt(j,i)-0.5)^2)/sigma) ;
  end ;
end ;
figure(2) ; 
mesh(xt,yt,zt) ; title('The real function') ;

[cper,cndper]=lndpercoef(x,z) ;
disp('Periodic gf interp.') ;
cndper
zp=xt ;
for i=1:nx,
  for j=1:ny,
    zp(j,i)=lndpereval([xt(j,i) yt(j,i)],x,cper) ;
  end ;
end ;

errp=sqrt(sum(sum((zp-zt).^2))) 

figure(3) ; 
mesh(xt,yt,zp) ; title('Interpolation periodized') ;

[cths,cndt]=lndthscoef(x,z) ;
disp('Thin plate splines interp.') ;
cndt
zh=xt ;
for i=1:nx,
  for j=1:ny,
    zh(j,i)=lndthseval([xt(j,i) yt(j,i)],x,cths) ;
  end ;
end ;

errp=sqrt(sum(sum((zh-zt).^2))) 


figure(4) ; 
mesh(xt,yt,zh) ; title('Thin plate splines') ;

