function [c,op1,op2]=lpmlopt(x,c0,T,d,p,deg)
% Optimize the lpeval criterion with respect to c
% x ... vector to approximate at positions 0,1,2,...,N-1, 
% c0,c ... Bspline coefficients c_0, c_1, ..., 
%          initial estimate (c0) and the final value (c)
% T ... spline spacing, d ... spline displacement, 
% p... norm order, deg ...spline degree,
%
% Jan Kybic, January 2000
% $Id: lpmlopt.m,v 1.1 2000/01/07 17:39:09 jkybic Exp $

if nargin==2,
  % invoked with two parameters, apparently from ML
  par=c0 ;
  c=x ; x=par.x ; T=par.T ; d=par.d ; p=par.p ; deg=par.deg ;
  [z,c,op1,op2]=lpeval(x,c,T,d,p,deg) ;
  op2=diag(op2) ; % ML expects a matrix while lpeval gives us only a diagonal
else
  % invoked with six parameters
  par.x=x ; par.T=T ; par.d=d ; par.p=p ; par.deg=deg ;
  c=marqlev('lpmlopt',c0,par) ;
  op1=0 ; op2=0 ;
end ;
