function c=lpmloptp(x,c0,T,d,p,deg)
% Optimize the lpeval criterion with respect to c
% using a multiresolution strategy
% x ... vector to approximate at positions 0,1,2,...,N-1, 
% c0,c ... Bspline coefficients c_0, c_1, ..., 
%          initial estimate (c0) and the final value (c)
% T ... spline spacing, d ... spline displacement, 
% p... norm order, deg ...spline degree,
%
% Jan Kybic, January 2000
% $Id: lpmloptp.m,v 1.1 2000/01/10 14:42:53 jkybic Exp $

% number of pyramid levels
pyrlev=max(1,ceil(log(length(c0))/log(2)-2)) ;
xpyr=pyramid2(x,pyrlev) ; % we use always cubic splines
cpyr=pyramid2(c0,pyrlev) ;

c=cpyr{pyrlev} ;
for i=pyrlev:-1:1,
  if i<pyrlev,
    cc=cputime ;
    c=L2pyramid_up(c,deg,'bspln','bspln') ;
  end ;
  x=xpyr{i} ; 
  N=length(x) ; tx=0:N-1 ; tw=0:0.1:N-1 ;
  tz=tw/T+d ; 
  c=lpmlopt(x,c,T,d,p,deg) ;
  z=mexsplninterp(c,tz,1,deg)' ;
  plot(tx,x,tw,z) ;
  pause(0.01) ;
  % keyboard
end ;

