function trylpeval()
% Try the lpeval and lpmlopt functions

% samples of a function we want to approximate
% x=[ 3 3 3 3 3.5 4 4.5 5 5.5 6 1 1 1 1 ]' ;
x=[ 3 3 3 3  3 3 3 3.25 3.5 3.75 4 4.25 4.5 4.75 5 5.25 5.5 5.75 6 ...
      1 1 1 1 1 1 1 1 ]' ;
x=L2pyramid_up(x,1) ;
x=L2pyramid_up(x,1) ;
x=L2pyramid_up(x,1) ;
x=L2pyramid_up(x,1) ;

% initial coefficients
% c=[ 1 5 7 -2 -1 0 1 2 1 5 7 -2 -1 0 1 2  ]' ;
% c=[ 1 5 7 -2]' ;
c= zeros(16,1) ;
N=length(x) 
tx=0:N-1 ;
% T=1.5 ; 
T=28 ; % node spacing
d=0 ; deg=3 ; p=1 ;
tw=0:0.1:N-1 ;
tz=tw/T+d ;
z=mexsplninterp(c,tz,1,deg)' ;
plot(tx,x,tw,z) ; legend('x','z') ;

[z,E,gr,Hd]=lpeval(x,c,T,d,p,deg) ;
if 0,
  gr
  h=1e-8 ;
  gre=c ;
  for i=1:length(c) ;
    ct=c ; ct(i)=ct(i)+h ;
    [z1,E1,gr1,Hd1]=lpeval(x,ct,T,d,p,deg) ;
    gre(i)=(E1-E)/h ;
  end ;
  gre
end ;

if 0,
p=2 ;
[z,E,gr,Hd]=lpeval(x,c,T,d,p,deg) ;
c1=lpmlopt(x,c,T,d,2,deg) ;
z1=mexsplninterp(c1,tz,1,deg)' ;
[z,Ea,gr,Hd]=lpeval(x,c1,T,d,p,deg) ;
plot(tx,x,tw,z1) ; legend('x','z') ;
evtn(x,c1,T,d,deg,p) ;
end ;

if 1,
p=3 ;
figure(1) ;
[z,E,gr,Hd]=lpeval(x,c,T,d,p,deg) ;
cc=cputime ;
c2=lpmlopt(x,c,T,d,p,deg) ;
disp(['Elapsed ' num2str(cputime-cc) 's']) ; 
z2=mexsplninterp(c2,tz,1,deg)' ;
[z,Ea,gr,Hd]=lpeval(x,c2,T,d,p,deg) ;
Ea
plot(tx,x,'o-',tw,z2) ; legend('x','p=3') ;
%evtn(x,c2,T,d,deg,p) ;
end ;

if 0,
p=1.5 ;
[z,E,gr,Hd]=lpeval(x,c,T,d,p,deg) ;
c3=lpmlopt(x,c,T,d,p,deg) ;
z3=mexsplninterp(c3,tz,1,deg)' ;
[z,Ea,gr,Hd]=lpeval(x,c3,T,d,p,deg) ;
plot(tx,x,'o-',tw,z1,tw,z2,tw,z3) ; legend('x','p=2','p=3','p=1.5') ;
grid on ;
evtn(x,c3,T,d,deg,p) ;
end ;

% Try pyramid optimization
p=3 ;
cc=cputime ;
c4=lpmloptp(x,c,T,d,p,deg) ;
disp(['Elapsed ' num2str(cputime-cc) 's']) ; 
z4=mexsplninterp(c4,tz,1,deg)' ;
[z,Ea,gr,Hd]=lpeval(x,c4,T,d,p,deg) ;
Ea
figure(2) ;
plot(tx,x,'o-',tw,z4) ; legend('x','pyramid p=3') ;
figure(3) ; plot(c4)

function evtn(x,c,T,d,deg,p)
[z,E15]=lpeval(x,c,T,d,1.5,deg) ;
[z,E2]=lpeval(x,c,T,d,2,deg) ;
[z,E3]=lpeval(x,c,T,d,3,deg) ;
disp([ 'p=' num2str(p) ' E1.5=' num2str(E15) ' E2=' num2str(E2) ' E3=' num2str(E3) ]) ;
