% tries the lpmgrid multigrid optimization
%
% Jan Kybic, January 2000
% $Id: trylpmgrid.m,v 1.2 2000/01/11 17:10:54 jkybic Exp $

% samples of a function we want to approximate
x=[ 3 3 3 3 3.5 4 4.5 5 5.5 6 1 1 1 1 ]' ;

% initial coefficients
c=[ 1 5 7 -2]' ;
N=length(x) ;
T=4 ; d=0 ; deg=3 ; p=3 ;
tx=0:N-1 ;
tw=0:0.1:N-1 ;
tz=tw/T+d ;
% evaluate the initial estimate at all points for further plotting
z=mexsplninterp(c,tz,1,deg)' ;

c2=lpmlopt(x,c,T,d,p,deg) ;
z2=mexsplninterp(c2,tz,1,deg)' ;

c1=lpmgrid(x,c,T,d,p,deg,1,1) ;
z1=mexsplninterp(c1,tz,1,deg)' ;

plot(tx,x,'-o',tw,z,tw,z1,tw,z2) ;
legend('x','z','z1','z2') ; grid on ; 

