function x=lsgaus(A,b)
% Solves x=A\b using Gauss iterative method
%
% Usage: x=lsgaus(A,b)
%
% Jan Kybic, June 2000
% $Id: lsgaus.m,v 1.1 2000/06/06 17:13:48 jkybic Exp $

abserr=1e-6 ; 

N=length(A) ;
b=b(:) ;

if size(b,1)~=N, error('Incorrect size for b') ; end ;

x=zeros(N,1) ; % initial estimate

J=sum((A*x-b).^2) ; % residual error
i=0 ; % number of iterations
disp(sprintf('Iteration %d. J=%g',i,J)) ;

while J>abserr,
  for j=1:N,
    x(j)=0 ; x(j)=(b(j)-A(j,:)*x)/A(j,j) ;
  end ;
  Jold=J ;
  J=sum((A*x-b).^2) ; % residual error
  i=i+1 ; 
  disp(sprintf('Iteration %d. J=%g',i,J)) ;
  if J>Jold, error('Not converging') ; end ;
end ;

