function [varargout]=tryconjgrad(x)
%  Try the conjgrad minimization routine
%  We minimize (x(1)-5)^4+(x(2)-6)^2 which should give x=[5;6]
%  $Id: tryconjgrad.m,v 1.1 1999/09/08 12:16:15 jkybic Exp $
%  Jan Kybic, 1999

if nargin==0,
  % Invoked with no arguments, start the test
  x=conjgrad('tryconjgrad',[1 1])
else
  % Invoked from conjgrad, to evaluate
  varargout{1}=(x(1)-5)^4+(x(2)-6)^2 ; % criterion
  varargout{2}=[4*(x(1)-5)^3 ; 2*(x(2)-6) ] ; % gradient
end ;
