function out=pyramid2(orig,level,outsp)
%PYRAMID  produces a pyramid of the image 'orig' at 'level' level.
% IN: orig must be double.
% OUT: cell array of pyramid. 
%      Adress with: out{level}
%
%  sub_2 = subsampled
%  card_2 = prefiltered with bspline of order 3
%  dual_2 = none meaningful result
%
%  Author: Stefan Horbelt, 23.4.98

% sinsin
% tyre, tartan, facets, wifs, madrill, geometry, detail, detfinger

% modified by JK not to plot anything, optimized, modifiable outsp 
% removed sub references
%
% $Id: pyramid2.m,v 1.2 1999/11/18 21:19:17 jkybic Exp $
% Jan Kybic, 1999

out=cell(level+1,1);
deg=3 ;
if nargin<3, outsp='cardinal' ; end ;

% Original:
%%%%%%%%%%%%%%%%%%%%%%%%%

out{1}=orig;

% Going down
%%%%%%%%%%%%%%%%%%%%%%%%%%

down=spspace(orig,deg,'card','dual') ;
% save converting to dual space every time

for l=1:level
  down=L2pyramid_down(down,3,'dual','dual');
  out{l+1}=spspace(down,3,'dual',outsp); 
end;
