% Test Stefan pyramid routines

y=[ 10 10 10 10 10 10 10 10 10 10 5 4 3 3 6 8 2 1 2 3 4 4 8 9 ... 
      10 10 10 10 10 10 10 10 ]' ;
% y=[ 10 10 10 9 8 7 7 6 6 5 5 6 6 5 1 1 2 4 6 8 10 10 10 10 10 10 9 8 7 7 6 ...
%      6 5 5 6 6 5 1 1 2 4 6 8 10 10 10 10 10 10 9 8 7 7 6 6 5 5 6 6 5 1 1 2 4 6 8 10 10 10 10 10 10 9 8 7 7 6 6 5 5 6 6 5 1 1 2 4 6 8 10 10 10 10 10 10 9 8 7 7 6 6 5 5 6 6 5 1 1 2 4 6 8 10 10 10 10 10 10 9 8 7 7 6 6 5 5 6 6 5 1 1 2 4 6 8 10 10 10 ]' ;

N=length(y) ;
t=0:0.1:N-1 ;
ti=0:N-1 ;
deg=3 ;

if 0,
figure(1) ; % pyramid in B-spline space
yc=fsplinem(y,deg) ;
yt=mexsplninterp(yc,t,1,deg) ;
cc=cputime ; 
ycd=L2pyramid_down(yc,deg,'bspline','bspline') ;
ycdu=L2pyramid_up(ycd,deg,'bspline','bspline') ;
disp(['@@@@@@@@@@@@@ Stefan ' num2str(cputime-cc) ' s' ]) ;
ycdut=mexsplninterp(ycdu,t,1,deg) ;
ycdt=mexsplninterp(ycd,t/2,1,deg) ;
plot(ti,y,'o',t,yt,t,ycdut,t,ycdt) ; 
legend('points','orig','down/up','down') ; grid on ;
end ;

if 0,
figure(3) ; % pyramid in cardinal space
yd=L2pyramid_down(y,deg,'card','card') ;
ydu=L2pyramid_up(yd,deg,'card','card') ;
plot(dyaddown(ti,1),yd,ti,y,ti,ydu) ; legend('down','orig','down/up') ; 
grid on ;
end ;

figure(3) ;
if 1,
load smallbarb
cc=cputime ;
imgd=L2pyramid_down(img,deg,'card','card') ;
disp(['reduce took ' num2str(cputime-cc) ' s' ]) ;
cc=cputime ;
imgdu=L2pyramid_up(imgd,deg,'card','card') ;
disp(['expand took ' num2str(cputime-cc) ' s' ]) ;
subplot(221) ; imagesc(img) ; title('original') ; colormap(pink) ;
subplot(222) ; imagesc(imgd) ; title('down') ;
subplot(223) ; imagesc(imgdu) ; title('down/up') ;
subplot(224) ; imagesc(abs(imgdu-img)) ; colorbar ; title('difference') ;
sum(sum((imgdu-img).^2)) 
end ;

if 0,
% Thierry's routines
figure(2) ;
[af,sf]=FFTfractsplinefilters(N,deg,'*bspline') ;
yc=fsplinem(y,deg) ;
yt=mexsplninterp(yc,t,1,deg) ;
cc=cputime ;
w=FFTwaveletanalysis(y',af,1) ;
ycd=w(N/2+1:N)' ;
w=[ zeros(1,N/2) ycd' ] ;
ycdu=FFTwaveletsynthesis(w,sf,1)' ;
disp(['@@@@@@@@@@@@@ Thierry ' num2str(cputime-cc) ' s' ]) ;
ycdut=mexsplninterp(fsplinem(ycdu,deg),t,1,deg) ;
ycdt=mexsplninterp(ycd/sqrt(2),t/2,1,deg) ;
plot(ti,y,'o',t,yt,t,ycdut,t,ycdt) ; 
legend('points','orig','down/up','down') ; grid on ;
end ;

%%%% 3D test
if 1, 
figure(4) ;
load smallbarb
vol=zeros(64,64,64) ;
for i=1:64,
  vol(:,i,:)=img ;
end ;
cc=cputime ;
vold=L2pyramid_down(vol,deg,'card','card') ;
disp(['reduce took ' num2str(cputime-cc) ' s' ]) ;
cc=cputime ;
voldu=L2pyramid_up(vold,deg,'card','card') ;
disp(['expand took ' num2str(cputime-cc) ' s' ]) ;
vimgd=squeeze(vold(:,31,:)) ;
vimgdu=squeeze(voldu(:,1,:)) ;
subplot(221) ; imagesc(img) ; title('original') ; colormap(pink) ;
subplot(222) ; imagesc(vimgd) ; title('down') ;
subplot(223) ; imagesc(vimgdu) ; title('down/up') ;
subplot(224) ; imagesc(abs(vimgdu-img)) ; colorbar ; title('difference') ;
sum(sum((vimgdu-img).^2)) 
end ;  
