function val=bpevalfdi(thetav,uv,c,x,y,T)
% Evaluates the reconstructed function using turned and shifted 
% functions optimal for the finite domain integration
%
% Usage: val=bpevalfdi(thetav,uv,c,x,y,T)
%
% thetav angles, uv offsets, c coefficients, x, y coordinates
%
% Jan Kybic, March 2000

nt=length(thetav) ;
nu=length(uv) ;

N=nt*nu+3 ;

val=c(N-2)+c(N-1)*x+c(N)*y ; 
for i1=1:nu, % sampling point
  for i2=1:nt,
    i=i1+nu*(i2-1) ;
    theta=thetav(i2) ; t=uv(i1) ;
    cost=cos(theta) ; sint=sin(theta) ;
    xp=cost*x+sint*y ; yp=-sint*x+cost*y ;
    val=val+c(i)*valv(yp,xp,t,T) ; % xp,yp intentionally swapped
  end ;
end ;

function val=valu(xp,yp); 
if xp~=0,
  val=-(0.5*yp*(3*xp^2+yp^2)*log(xp^2+yp^2)+2*xp^3*atan(yp/xp))/12/pi ;
else
  if yp~=0,
    val=-yp^3*log(yp^2)/24/pi ;
  else
    val=0 ;
  end ;
end ;

function val=valv(xp,yp,t,T) ;
st=sqrt(T^2-t^2) ;
val=0.5*(valu(xp-t,yp+st)-valu(xp-t,yp-st)) ;

