function val=bpevalsob(thetav,uv,c,x,y,gamma)
% Evaluates the reconstructed function using turned and shifted 
% Sobolev interpolation for the tomographical reconstruction problem
%
% Usage: val=bpevalxthr(thetav,uv,c,x,y)
%
% thetav angles, uv offsets, c coefficients, x, y coordinates
%
% Jan Kybic, March 2000

nt=length(thetav) ;
nu=length(uv) ;
s=gamma^(-1/4)/sqrt(2) ;
alpha=1/4/sqrt(2)/s^3 ;

N=nt*nu ;

val=0 ;
for i1=1:nu, % sampling point
  for i2=1:nt,
    i=i1+nu*(i2-1) ;
    r=abs(cos(thetav(i2))*y-sin(thetav(i2))*x-uv(i1)) ;
    sr=s*r ;
    val=val+c(i)*alpha*(exp(-sr)*(sin(sr+pi/4))) ;
  end ;
end ;


