function val=bpevalxfrs(thetav,uv,c,x,y)
% Evaluates the reconstructed function using turned and shifted |x| 
% interpolation for the tomographical reconstruction problem
%
% Usage: val=bpevalxfrs(thetav,uv,c,x,y)
%
% thetav angles, uv offsets, c coefficients, x, y coordinates
%
% Jan Kybic, March 2000

nt=length(thetav) ;
nu=length(uv) ;

N=nt*nu+1 ;

val=c(N) ; 
for i1=1:nu, % sampling point
  for i2=1:nt,
    i=i1+nu*(i2-1) ;
    val=val+c(i)*abs(-sin(thetav(i2))*x+cos(thetav(i2))*y-uv(i1))/2 ;
  end ;
end ;


