function val=bpevalxthr(thetav,uv,c,x,y)
% Evaluates the reconstructed function using turned and shifted |x|^3 
% interpolation for the tomographical reconstruction problem
%
% Usage: val=bpevalxthr(thetav,uv,c,x,y)
%
% thetav angles, uv offsets, c coefficients, x, y coordinates
%
% Jan Kybic, March 2000

nt=length(thetav) ;
nu=length(uv) ;

N=nt*nu+3 ;

val=c(N-2)+c(N-1)*x+c(N)*y ; 
for i1=1:nu, % sampling point
  for i2=1:nt,
    i=i1+nu*(i2-1) ;
    val=val+c(i)*abs(-sin(thetav(i2))*x+cos(thetav(i2))*y-uv(i1))^3/12 ;
  end ;
end ;


