function val=intgrimg(img,x1,y1,x2,y2)
% Calculate a line integral of img on line (x1,y1)->(x2,y2)
% all coordinates have a Matlab conventions
%
% Jan Kybic, March 2000
%
% $Id: intgrimg.m,v 1.4 2000/04/26 18:06:45 jkybic Exp $

[ny,nx]=size(img) ;
xd=x2-x1 ; yd=y2-y1 ;
ll=sqrt(xd.^2+yd.^2) ;
osf=10 ; % was 10
t=linspace(0,1,ceil(ll*osf*sqrt(2))) ;
step=(t(2)-t(1))*ll ;
tx=x1+t*xd ; ty=y1+t*yd ;
z=interp2(img,tx,ty,'*cubic') ;
z(find(isnan(z)))=0 ;
val=sum(z)*step ;