% Show the consistency of the reconstruction

clear all ;
nt=8 ;
nu=32 ; % number of samples per direction
N=256 ; % size of the image
scl=1 ;

lntv=2 ; num=1 ;
%head=phantom('Modified Shepp-Logan',N) ;
tmp=evalbspline(((1:N)-N/2)/20,2) ;
for i=1:N,
    head(i,:)=tmp ;
  end ;
head=head' ;  
 


subplot(lntv,3,1) ; imagesc(head) ; colormap(gray) ; colorbar ;
title('Phantom') ;

thetav=(0:(nt-1))*pi/nt ; % angles
T=N/2*sqrt(2) ; % reconstruction circle diameter
uv=linspace(-T*0.8,T*0.8,nu+2) ; uv=uv(2:nu+1) ;

pause(0.01) ;
% reconstruction with |x|^3
if 1,
  Rp=radonpix(head,thetav,uv) ;
  disp('bpgetcoefxthr called') ;
  [c,cm]=bpgetcoefxthr(thetav,uv,Rp,T) ;
  disp('Coefs found') ;
  [ny,nx]=size(head) ;
  NN=scl*ceil(T) ;
  
  rimg=mexbpevalthrimg(thetav,uv,c,[2*NN+1 2*NN+1],1/scl) ;
  disp('Now masking') ;
  yv=linspace(-NN,NN,NN*2+1) ; xv=yv ;
  [xt,yt]=meshgrid(xv,yv) ;
  %rimg=zeros(2*NN,2*NN) ; % reconstructed image
  rimg=rimg.*(xt^2+yt^2<scl^2*T^2) ;
  %for xi=1:NN*2,
  %  for yi=1:NN*2,
  %   if (xt(yi,xi)^2+yt(yi,xi)^2>scl^2*T^2), rimg(yi,xi)=0 ; end ;
  %	rimg(yi,xi)=bpevalxthr(thetav,uv,c,xt(yi,xi),yt(yi,xi)) ;
  %    end ;
  %  end ;
  % end ;
end ;

subplot(lntv,3,3*num-1) ; imagesc(rimg,[0 1]) ; colormap(gray) ; axis off ;
colorbar ; title(sprintf('x3circ nu=%d',nu)) ;

if 1, % check Radon
  disp('Checking radon') ;
  % R1=radonpix(rimg,thetav,uv*scl)/scl ;
  R1=radonxthr(c,thetav,uv,T,1e-8) ;
  % [R1,uv1]=radon(rimg,thetav/pi*180,nu) ;
  % R1=R1/(N*sqrt(2)/nu) ;
  subplot(lntv,3,3) ;
  plot([ Rp(1,:)'  R1(1,:)' cm(1:nu)]) ;
  legend('measured','reconstructed','calculated') ;
  subplot(lntv,3,4) ;
  plot([ Rp(2,:)' R1(2,:)' cm(nu+1:2*nu) ]) ;
  subplot(lntv,3,5) ;
  plot([ Rp(3,:)' R1(3,:)' cm(2*nu+1:3*nu) ]) ;
  subplot(lntv,3,6) ;
  plot([ Rp(4,:)' R1(4,:)' cm(3*nu+1:4*nu) ]) ;
  sum(sum(abs(R1-Rp)))/N
end ;  
% subplot(335) ; imagesc(abs(rimg-head)) ; colormap(gray) ; axis off ;
%colorbar ; title('x3circ diff') ;

