%nt=32 ;
nt=8 ;
nu=17 ;
N=256 ;
T=128 ;

thetav=(0:(nt-1))*pi/nt ; % angles
uv=(1:nu)*2*T/(nu+1)-T ;
ctrue=zeros(nt*nu+3,1) ;
load cb1
%ctrue((nu-1)/2:(nu-1)/2+2)=[ -T/sqrt(T^2-1) 2 -T/sqrt(T^2-1) ] ;
%ctrue(1:17)=ctrue(1:17)+randn(17,1)*0.01 ;
ctrue((nu-1)/2-2:(nu-1)/2+4)=cb1 ;

head=mexbpevalthrimg(thetav,uv,ctrue,[N N],1) ;
yv=(1:N)-((N+1)/2) ;
xv=(1:N)-((N+1)/2) ;
[xt,yt]=meshgrid(xv,yv) ;
mask=(xt.^2+yt.^2<T^2) ;
head=head.*mask ;
imagesc(head) ; colormap(gray) ; colorbar ; axis image
title('Phantom') ;


Rp=radonxthrexact(ctrue,thetav,uv,T) ;
Rp=Rp.*(1+1e-2*randn(nt,nu)) ;
disp('bpgetcoefxthr called') ;
c=bpgetcoefxthr(thetav,uv,Rp,T) ;
disp('Coefs found') ;
rimg=mexbpevalthrimg(thetav,uv,c,[N N],1) ;
disp('Masking') ;
rimg=rimg.*mask ;

figure(3) ;
imagesc(rimg) ; colormap(gray) ; axis image ;
colorbar ; title(sprintf('x3circ nu=%d nt=%d',nu,nt)) ;
pause(0.01) ;

figure(4) ; 
subplot(211) ;
plot([ head(:,128) rimg(:,128)]) ;
title('Vertical cut') ;
subplot(212) ;
plot(head(:,128)-rimg(:,128)) ;
title('Difference') ;
legend('original','variational') ;

  