% Tries backprojection with RBF

clear all ;
nt=5 ; % number of theta projection angles
%thetav=[0 pi/2] ; % projection angles
% thetav=[0 2*pi/3 4*pi/3 ] ; % projection angles
thetav=(0:(nt-1))*pi/nt ;

N=128 ;
R=N/4 ; % test object is a disc of radius R
%T=2*sqrt(2) ; % limits of the integral (t=-T..T)
T=N ;
%[yt,xt]=meshgrid(-2:0.02:2,-2:0.02:2) ;
yv=linspace(-N/2,N/2,N) ; xv=yv ;
[xt,yt]=meshgrid(xv,yv) ;

trf=(yt.^2+xt.^2<R^2) ;
figure(1) ; subplot(211) ;
imagesc(trf) ; title('Phantom') ; axis image ; colormap(gray) ;

nu=8 ; % number of positions u for each projection
uv=linspace(-0.9*T,0.9*T,nu) ;

mts=radonpix(trf,thetav,uv) ;

subplot(212) ; plot(uv,mts(1,:),'o-') ; title('projection') ;

c=bpgetcoefxthr(thetav,uv,mts,T) ;
%c=bpgetcoefxfrs(thetav,uv,mts,T) ;
%c=bpgetcoeffdi(thetav,uv,mts,T) ;
%gamma=10 ;
%c=bpgetcoefsob(thetav,uv,mts,T,gamma) ;

% evaluation
[ny,nx]=size(yt) ;
if 0,
  rimg=zeros(ny,nx) ; % reconstructed image
  for xi=1:nx,
    for yi=1:ny,
      x=xt(yi,xi) ; y=yt(yi,xi) ; 
      rimg(yi,xi)=bpevalxthr(thetav,uv,c,x,y) ;
      %    rimg(yi,xi)=bpevalxfrs(thetav,uv,c,x,y); 
      %    rimg(yi,xi)=bpevalsob(thetav,uv,c,x,y,gamma) ;
      %    rimg(yi,xi)=bpevalfdi(thetav,uv,c,x,y,T) ;
    end ;
  end ;
else
  rimg=mexbpevalthrimg(thetav,uv,c,[ny nx]) ;
end ;

figure(3) ;  imagesc(xt(:,1),yt(1,:),rimg) ; colorbar ;

figure(2) ; plot(yt(1,:),sum(rimg),uv,mts(1,:),'o-')
figure(4) ; [cnc,cnh]=contour(xt,yt,rimg,20) ; colorbar ;

sum(sum((rimg-trf).^2))