% Try reconstruction using various methodes

ntv=[4 8 16] ;
ntv=16 ;
nu=32 ; % number of samples per direction
N=256 ; % size of the image
%N=2048 ; % size of the image

%gamma=1e3 ;
%gamma=1e5 ;


figure(1) ;
% Phantom
[head,E]=phantom('Modified Shepp-Logan',N) ;
E(1,2)=E(1,3) ; E(2,2)=E(2,3) ;
T=0.95*N*E(2,3)/2 ; % 95% of the true diameter of the phantom (inner circle)
%T=N/2 ;
head=phantom(N,E) ;

% Lena
%head=double(imread('/home/jkybic/matlab/images/lenahat.tiff')) ;
%head=head-mean(mean(head)) ;
%headf=imhpfilter(0.01,head) ; imagesc(headf) ; axis image
%head=headf ;

%[xts,yts]=meshgrid(1:N,1:N) ;
%head=zeros(N) ;
%n4=ceil(N/4) ; n3=ceil(N/3) ;
%for i=n4:3*n4,
%  head(i,n3:2*n3)=ones(1,n3+1) ;
%end ;

% Spline
%tmp=evalbspline(((1:N)-N/2)/40,3) ;
%for i=1:N,
%    head(:,i)=tmp' ;
%  end ;
%head=head' ;  
  

%head(128,128)=1000 ;
%head=imgaussfilt(head,30) ;
%head=imgaussfilt(head',30)' ;

[ny,nx]=size(head) ;
N=min([ny nx]) ;
%T=N/2 ;
%T=N/2 ; % N*sqrt(2) ;
yv=(1:ny)-((ny+1)/2) ;
xv=(1:nx)-((nx+1)/2) ;
[xt,yt]=meshgrid(xv,yv) ;
mask=(xt.^2+yt.^2<T^2) ;
head=head.*mask ;
imagesc(head) ; colormap(gray) ; colorbar ; axis image
title('Phantom') ;

figure(2) ;

lntv=length(ntv) ;

for num=1:lntv,
  nt=ntv(num)

  thetav=(0:(nt-1))*pi/nt ; % angles

  scl=N/nu ;
  [R,uv]=radon(head,thetav/pi*180,nu) ;
  % R has nu column and nt rows
  if 1, % backprojection
    iN=floor(nu/sqrt(2)) ;
    recbps=iradon(R,thetav/pi*180,'linear','Ram-Lak',1,iN) ;
    yvs=linspace(-ny/2,ny/2,iN) ; 
    xvs=linspace(-nx/2,nx/2,iN) ;
    [xts,yts]=meshgrid(xvs,yvs) ;
    recbp=interp2(xts,yts,recbps,xt,yt) ; 
    % subplot(lntv,3,num*3-2) ;
    figure(2) ;
    recbp=recbp.*mask ;
    imagesc(recbp) ; colormap(gray) ; axis image ; colorbar ;
    qt=sprintf('Backprojection nt=%d nu=%d',nt,nu) ;
    title(qt) ;
    pause(0.01) ;
    %  subplot(333) ; imagesc(abs(recbp-head)) ; colormap(gray) ; axis off ;colorbar ;
    %  title('Backprojection difference') ;
  end ;

  uvm=uv' ; thetavm=pi/2-thetav ;
  % T=N*sqrt(2)/2 ; 
  uvm=linspace(-T,T,nu+2) ; 
  uvm=uvm(2:nu+1) ;
  Rp=radonpix(head,thetavm,uvm,T) ;
%  explicit calculation of Rp
%   Rp=zeros(2,nu) ;
%   Rp(2,:)=40*ones(1,nu) ;
%   Rp(1,:)=(evalbspline(uvm/40,3).*2.*sqrt(T^2-uvm.^2)) ;
   
  % reconstruction with |x|^3
  if 1,
    disp('bpgetcoefxthr called') ;
    gamma=1e4 ;
    c=bpgetcoefxthr(thetavm,uvm,Rp,T,gamma) ;
    disp('Coefs found') ;
    [ny,nx]=size(yt) ;
    rimg=mexbpevalthrimg(thetavm,uvm,c,[ny nx],1) ;
    %rimg=zeros(ny,nx) ; % reconstructed image
    disp('Masking') ;
    rimg=rimg.*mask ;
%    for xi=1:nx,
%      for yi=1:ny,
%	if (xt(yi,xi)^2+yt(yi,xi)^2>T^2) rimg(yi,xi)=0 ;
%    	rimg(yi,xi)=bpevalxthr(thetavm,uvm,c,xt(yi,xi),yt(yi,xi)) ;
%      end ;
%    end ;

    % subplot(lntv,3,3*num-1) ; 
    figure(3) ;
    imagesc(rimg,[ 0 max(max(head))]) ; colormap(gray) ; axis image ;
    colorbar ; title(sprintf('x3circ nu=%d nt=%d gamma=%g',nu,nt,gamma)) ;
    pause(0.01) ;

    if 0, % check Radon
      [R1,uv1]=radon(rimg,thetav/pi*180,nu) ;
      R1=R1 ;
      subplot(4,2,3) ;
      plot([ R(:,1) R1(:,1) ]) ;
      subplot(4,2,4) ;
      plot([ R(:,2) R1(:,2) ]) ;
      subplot(4,2,5) ;
      plot([ R(:,3) R1(:,3) ]) ;
      subplot(4,2,6) ;
      plot([ R(:,4) R1(:,4) ]) ;
    end ;  
    % subplot(335) ; imagesc(abs(rimg-head)) ; colormap(gray) ; axis off ;
    %colorbar ; title('x3circ diff') ;
  
%    figure(4) ; fimg=imhpfilter(0.05,rimg) ; 
%    imagesc(fimg) ; colorbar ; colormap(gray) ; axis image ;
%    title('Filtered x3circ') ;
%    figure(4) ; plot([ head(128,:)' rimg(128,:)' recbp(128,:)'/70])
%    legend('original','variational','scaled bp') ;
%    title('Vertical cut') ;
    
  end ;

  if 0,
    % reconstruction with |x|
    % T=N*sqrt(2) ; 
    disp('bpgetcoefxfrs called') ;
    c1=bpgetcoefxfrs(thetavm,uv,R',T) ;
    disp('Coefs found') ;
    [ny,nx]=size(yt) ;
    rimg1=zeros(ny,nx) ; % reconstructed image
    for xi=1:nx,
      for yi=1:ny,
	rimg1(yi,xi)=bpevalxfrs(thetavm,uv,c,xt(yi,xi),yt(yi,xi)) ;
      end ;
    end ;

    subplot(lntv,3,3*num) ; imagesc(rimg1) ; colormap(gray) ; axis image ;
    colorbar ; title('x1circ') ;
    %subplot(337) ; imagesc(abs(rimg1-head)) ; colormap(gray) ; axis off ;
    %colorbar ; title('x1circ diff') ;
  end ;

  if 0,
    % reconstruction with the optimal functions
    % T=N*sqrt(2) ; 
    disp('bpgetcoeffdi called') ;
    gamma=1 ;
    c1=bpgetcoeffdi(thetavm,uvm,Rp,T,gamma) ;
    disp('Coefs found') ;
    [ny,nx]=size(yt) ;
    %rimg1=zeros(ny,nx) ; % reconstructed image
    %for xi=1:nx,
    %  for yi=1:ny,
    %	rimg1(yi,xi)=bpevalfdi(thetavm,uvm,c1,xt(yi,xi),yt(yi,xi),T) ;
    %  end ;
    %end ;
    rimg1=mexbpevalfdiimg(thetavm,uvm,c1,T,[ny nx]) ;
    %rimg=zeros(ny,nx) ; % reconstructed image
    %disp('Masking') ;
    %rimg=rimg.*mask ;

    figure(4) ;
    imagesc(rimg1,[0 max(max(head))]) ; colormap(gray) ; axis image ;

    % subplot(lntv,3,3*num) ; imagesc(rimg1) ; colormap(gray) ; axis off ;
    colorbar ; 
    title(sprintf('finite domain functions nu=%d nt=%d gamma=%g',nu,nt,gamma)) ;
    %subplot(337) ; imagesc(abs(rimg1-head)) ; colormap(gray) ; axis off ;
    %colorbar ; title('x1circ diff') ;
  end ;

end ; % of the for cyclus

if 0,
figure(5) ;
imagesc(abs(head-rimg1)) ; colorbar ; colormap(hot) ;
title('Reconstruction error') ;

npix=ny*nx ;
l2epp=sqrt(sum(sum((head-rimg1).^2))/sum(sum(head.^2))) ;
disp(['relative l2 error per pixel (wrt max) ' num2str(l2epp)]) ;
Rq=radonpix(rimg1,thetavm,uvm,T) ;
%Rq=radonxthr(c,thetavm,uvm,T,1e-6) ;
%Rw=radonxthrexact(c,thetavm,uvm,T) ;

l2rerr=sqrt(sum(sum((Rp-Rq).^2))/sum(sum(Rp.^2))) ;
disp(['relative mean l2 discrepancy of the measures ' num2str(l2rerr)]) ;

%figure(5) ; 
%plot([reshape(Rp,1,nu*nt)' reshape(Rq,1,nu*nt)'])
%title('Measures') ; legend('original','reconstruction') ;

figure(4) ;
h=text(1,240,['relative l2 error per pixel ' num2str(l2epp)]) ;
set(h,'Color',[1 1 1])  ;
h=text(1,250,['relative mean l2 discrepancy of the measures ' ...
      num2str(l2rerr)]) ;
set(h,'Color',[1 1 1])  ;



end ;