% Reconstruct using averaged Radon measures

nt=32 ; nu=32 ;

head=double(imread('/home/jkybic/matlab/images/lenahat.tiff')) ;
[ny,nx]=size(head) ;
N=min([ny nx]) ;
T=N/2 ; % N*sqrt(2) ;
yv=(1:ny)-((ny+1)/2) ;
xv=(1:nx)-((nx+1)/2) ;
[xt,yt]=meshgrid(xv,yv) ;
mask=(xt.^2+yt.^2<T^2) ;
head=head.*mask ;

figure(1) ;
imagesc(head) ; colormap(gray) ; colorbar ; axis image
title('Phantom') ;

thetav=(0:(nt-1))*pi/nt ; % angles
uv=linspace(-T,T,nu+2) ; 
uv=uv(2:nu+1) ;
uvstep=uv(2)-uv(1) ;
smf=5 ; % how many projections to combine
% new coordinates for Radon projections
uvf=linspace(uv(1)-uvstep*(1-1/smf)/2,uv(nu)+uvstep*(1-1/smf)/2,nu*smf) ;

Rp=radonpix(head,thetav,uvf,T) ;
Rw=radonpix(head,thetav,uv,T) ;

% combine Radon measures
Rq=zeros(nt,nu) ;
for iu=0:nu-1,
    Rq(:,iu+1)=mean(Rp(:,iu*smf+1:iu*smf+smf)')' ;
end ;

disp('bpgetcoefxthr called') ;
gamma=1000 ;
c=bpgetcoefxthr(thetav,uv,Rq,T,gamma) ;
disp('Coefs found') ;
rimg=mexbpevalthrimg(thetav,uv,c,[ny nx],1) ;
disp('Masking') ;
rimg=rimg.*mask ;

figure(2) ;
imagesc(rimg,[ 0 max(max(head))]) ; colormap(gray) ; axis image ;
colorbar ; title(sprintf('x3circ nu=%d nt=%d gamma=%g averaged Radon',nu,nt,gamma)) ;
pause(0.01) ;



disp('bpgetcoefxthr called') ;
c1=bpgetcoefxthr(thetav,uv,Rw,T,gamma) ;
disp('Coefs found') ;
rimg1=mexbpevalthrimg(thetav,uv,c1,[ny nx],1) ;
disp('Masking') ;
rimg1=rimg1.*mask ;

figure(3) ;
imagesc(rimg1,[ 0 max(max(head))]) ; colormap(gray) ; axis image ;
colorbar ; title(sprintf('x3circ nu=%d nt=%d gamma=%g',nu,nt,gamma)) ;
pause(0.01) ;

