% Try reconstruction using |x|^3, reconstruct basis function

nt=3 ; % the number of angles
nu=16 ; % number of samples per direction
N=256 ; % size of the image
%N=2048 ; % size of the image

figure(1) ;
ctrue=zeros(nt*nu+3,1) ;
ctrue(5:9)=[ 1    -4     6    -4     1]/12/N  ;
ctrue=ctrue+1e-2*randn(nt*nu+3,1) ;
ny=N ; nx=N ;
thetav=(0:(nt-1))*pi/nt ; % angles
T=N/2 ; % integration circle radius ;
uv=linspace(-T*0.9,T*0.9,nu) ; 
head=mexbpevalthrimg(thetav,uv,ctrue,[ny nx],1) ;
yv=(1:ny)-((ny+1)/2) ;
xv=(1:nx)-((nx+1)/2) ;
[xt,yt]=meshgrid(xv,yv) ;
mask=(xt.^2+yt.^2<T^2) ;
head=head.*mask ;
imagesc(head) ; colormap(gray) ; colorbar ; axis image
title('Phantom') ;

%Rp=radonpix(head,thetav,uv) ;
%Rp=radonxthr(ctrue,thetav,uv,T,1e-6) ;
Rp=radonxthrexact(ctrue,thetav,uv,T) ;

disp('bpgetcoefxthr called') ;
c=bpgetcoefxthr(thetav,uv,Rp,T) ;
disp('Coefs found') ;
rimg=mexbpevalthrimg(thetav,uv,c,[ny nx],1) ;
disp('Masking') ;
rimg=rimg.*mask ;

figure(3) ;
imagesc(rimg) ; colormap(gray) ; axis image ;
colorbar ; title(sprintf('x3circ nu=%d nt=%d',nu,nt)) ;
pause(0.01) ;

figure(4) ; 
subplot(211) ;
plot([ head(:,128) rimg(:,128)]) ;
title('Vertical cut') ;
subplot(212) ;
plot(head(:,128)-rimg(:,128)) ;
title('Difference') ;
legend('original','variational') ;

    

