% Try reconstruction using cubic B-splines wavelets

%nt=32 ; % the number of angles
%nuh=63 ; % half of the number of samples per direction
nuh=16 ; nt=16 ;
N=256 ; % size of the image
%N=2048 ; % size of the image

figure(1) ;
nu=nuh*2-1 ;
%ctrue=zeros(nt*nu+3,1) ;
%ctrue(5:9)=[ 1    -4     6    -4     1]/16/N  ;
% ctrue=ctrue+1e-2*randn(nt*nu+3,1) ;
%ctrue=zeros(nt*nu,1) ;
%ctrue=randn(nt*nu,1) ;
ny=N ; nx=N ;
thetav=(0:(nt-1))*pi/nt ; % angles
%T=N/2 ; % integration circle radius ;
%uv=linspace(-T*0.9,T*0.9,nu) ; 
%head=mexbpevalcbspln(thetav,nuh,du,ctrue,[ny nx]) ;
[head,E]=phantom('Modified Shepp-Logan',N) ;
E(1,2)=E(1,3) ; E(2,2)=E(2,3) ;
T=0.95*N*E(2,3)/2 ;
head=phantom(N,E) ;
du=(0.9*T)/nuh ;
uv=((1:nu)-nuh)*du ;

yv=(1:ny)-((ny+1)/2) ;
xv=(1:nx)-((nx+1)/2) ;
[xt,yt]=meshgrid(xv,yv) ;
mask=(xt.^2+yt.^2<T^2) ;
head=head.*mask ;
%head=mask ;
imagesc(head) ; colormap(gray) ; colorbar ; axis image
title('Phantom') ;

Rp=radonpix(head,thetav,uv) ;
%Rp=radonxthr(ctrue,thetav,uv,T,1e-6) ;
%Rp=radonxthrexact(ctrue,thetav,uv,T) ;

disp('bpgetcoefcbwav called') ;
gamma=0 ;
c=bpgetcoefcbwav(thetav,nuh,du,Rp,T,gamma) ;
disp('Coefs found') ;
rimg=mexbpevalcbspln(thetav,nuh,du,c,[ny nx]) ;
disp('Masking') ;
rimg=rimg.*mask ;

figure(3) ;
imagesc(rimg,[0 1]) ; colormap(gray) ; axis image ;
colorbar ; title(sprintf('cubic splines nu=%d nt=%d',nu,nt)) ;
pause(0.01) ;

%figure(4) ; 
%subplot(211) ;
%plot([ head(:,128) rimg(:,128)]) ;
%title('Vertical cut') ;
%subplot(212) ;
%plot(head(:,128)-rimg(:,128)) ;
%title('Difference') ;
%legend('original','variational') ;

figure(4) ;
imagesc(abs(head-rimg)) ; colorbar ; colormap(hot) ;
title('Reconstruction error') ;

npix=ny*nx ;
l2epp=sqrt(sum(sum((head-rimg).^2))/sum(sum(head.^2))) ;
disp(['relative l2 error per pixel ' num2str(l2epp)]) ;
Rq=radonpix(rimg,thetav,uv) ;
l2rerr=sqrt(sum(sum((Rp-Rq).^2))/sum(sum(Rp.^2))) ;
disp(['relative mean l2 discrepancy of the measures ' num2str(l2rerr)]) ;

figure(3) ;
h=text(1,240,['relative l2 error per pixel ' num2str(l2epp)]) ;
set(h,'Color',[1 1 1])  ;
h=text(1,250,['relative mean l2 discrepancy of the measures ' ...
      num2str(l2rerr)]) ;
set(h,'Color',[1 1 1])  ;


