/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:49:36 1999
 * Arguments: "-x" "-h" "lndradimg.m" 
 */
#include "fspline.h"
#include "filiirs.h"

static double __Array0_r[2] = { -0.361341, -0.0137254 };

static double __Array1_r[2] = { -0.430575, -0.0430963 };

static double __Array2_r[3] = { -0.488295, -0.0816793, -0.00141415 };

static double __Array3_r[3] = { -0.53528, -0.122555, -0.00914869 };

static double __Array4_r[2] = { -0.361341, -0.0137254 };

static double __Array5_r[2] = { -0.430575, -0.0430963 };

static double __Array6_r[3] = { -0.488295, -0.0816793, -0.00141415 };

static double __Array7_r[3] = { -0.53528, -0.122555, -0.00914869 };

/*
 * The function "Mfspline" is the implementation version of the "fspline"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/fspline.m" (lines
 * 1-81). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function y=fspline(x,iorder)
 */
static mxArray * Mfspline(int nargout_, mxArray * x, mxArray * iorder) {
    mxArray * y = mclGetUninitializedArray();
    mxArray * c0 = mclGetUninitializedArray();
    mxArray * z = mclGetUninitializedArray();
    mclValidateInputs("fspline", 2, &x, &iorder);
    /*
     * % FSPLINE(X,N) returns the B-spline coefficients of order N of the signal x.
     * %
     * % Given values (x) of a function in points 1,2,...n, 
     * % finds coefficients c, such as for all k=1..n
     * %    x(k)=sum  c(i) spline_of_order_N(k-i),   for i=1..n
     * %
     * % i.e., finds B-spline interpolation 
     * %
     * % This function uses a FIR filter thus it is faster than qbanal and cbanal,
     * % with usually negligible loss in accuracy. The FIR kernel is so far
     * % implemented only in C as a MEX file.
     * %
     * % References : 
     * % M. Unser, A. Aldroubi and M. Eden, "Fast B-spline transforms for
     * % continuous image representation and interpolation", IEEE Trans. Pattern Anal.
     * % Machine Intell., vol. 13, pp. 277-285, March 1991.
     * % M. Unser, A. Aldroubi and M. Eden, "B-spline signal processing. Part II :
     * % efficient design and applications", IEEE Trans. Signal Processing, vol. 41,
     * % pp. 834-848, February 1993.
     * %
     * %
     * % See also: qbanal.m cbanal.m
     * % Uses: filiirs.c
     * %
     * % Usage: y=fspline(x,N)
     * %
     * % $Id: fspline.m,v 1.1 1999/09/08 17:17:02 jkybic Exp $
     * 
     * if 0,  % M.U. - using M.U. routines must be enabled in filiirs.c as well
     */
    if (mlfTobool(mlfScalar(0.0))) {
        /*
         * if iorder==0   
         */
        if (mlfTobool(mlfEq(iorder, mlfScalar(0.0)))) {
            /*
             * y=x; return
             */
            mlfAssign(&y, x);
            goto return_;
        /*
         * elseif iorder==1   
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(1.0)))) {
            /*
             * y=x; return
             */
            mlfAssign(&y, x);
            goto return_;
        /*
         * elseif iorder==2 
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(2.0)))) {
            /*
             * z=-3+2.*sqrt(2);c0=8;
             */
            mlfAssign(
              &z,
              mlfPlus(
                mlfScalar(-3.0),
                mlfTimes(mlfScalar(2.0), mlfSqrt(mlfScalar(2.0)))));
            mlfAssign(&c0, mlfScalar(8.0));
        /*
         * elseif iorder==3
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(3.0)))) {
            /*
             * z=-2+sqrt(3);c0=6;
             */
            mlfAssign(&z, mlfPlus(mlfScalar(-2.0), mlfSqrt(mlfScalar(3.0))));
            mlfAssign(&c0, mlfScalar(6.0));
        /*
         * elseif iorder==4
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(4.0)))) {
            /*
             * z=[-0.361341 -0.0137254];c0=384;
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 2, __Array0_r, NULL));
            mlfAssign(&c0, mlfScalar(384.0));
        /*
         * elseif iorder==5
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(5.0)))) {
            /*
             * z=[-0.430575 -0.0430963];c0=120;
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 2, __Array1_r, NULL));
            mlfAssign(&c0, mlfScalar(120.0));
        /*
         * elseif iorder==6
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(6.0)))) {
            /*
             * z=[-0.488295 -0.0816793 -0.00141415];c0=46080;
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 3, __Array2_r, NULL));
            mlfAssign(&c0, mlfScalar(46080.0));
        /*
         * elseif iorder==7
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(7.0)))) {
            /*
             * z=[-0.53528 -0.122555 -0.00914869];c0=5040;
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 3, __Array3_r, NULL));
            mlfAssign(&c0, mlfScalar(5040.0));
        /*
         * else
         */
        } else {
            /*
             * error('Order not available')
             */
            mlfError(mxCreateString("Order not available"));
            /*
             * return
             */
            goto return_;
        /*
         * end
         */
        }
    /*
     * 
     * else % P.T.   
     */
    } else {
        /*
         * if iorder==0   
         */
        if (mlfTobool(mlfEq(iorder, mlfScalar(0.0)))) {
            /*
             * y=x; return
             */
            mlfAssign(&y, x);
            goto return_;
        /*
         * elseif iorder==1   
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(1.0)))) {
            /*
             * y=x; return
             */
            mlfAssign(&y, x);
            goto return_;
        /*
         * elseif iorder==2 
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(2.0)))) {
            /*
             * z=-3+2.*sqrt(2);c0=24-sqrt(512);
             */
            mlfAssign(
              &z,
              mlfPlus(
                mlfScalar(-3.0),
                mlfTimes(mlfScalar(2.0), mlfSqrt(mlfScalar(2.0)))));
            mlfAssign(
              &c0, mlfMinus(mlfScalar(24.0), mlfSqrt(mlfScalar(512.0))));
        /*
         * elseif iorder==3
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(3.0)))) {
            /*
             * z=-2+sqrt(3);c0=12-sqrt(108);
             */
            mlfAssign(&z, mlfPlus(mlfScalar(-2.0), mlfSqrt(mlfScalar(3.0))));
            mlfAssign(
              &c0, mlfMinus(mlfScalar(12.0), mlfSqrt(mlfScalar(108.0))));
        /*
         * elseif iorder==4
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(4.0)))) {
            /*
             * z=[-0.361341 -0.0137254];
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 2, __Array4_r, NULL));
            /*
             * c0=(1-z(1))*(1-z(2))^2 ;
             */
            mlfAssign(
              &c0,
              mlfMtimes(
                mlfMinus(mlfScalar(1.0), mlfIndexRef(z, "(?)", mlfScalar(1.0))),
                mlfMpower(
                  mlfMinus(
                    mlfScalar(1.0), mlfIndexRef(z, "(?)", mlfScalar(2.0))),
                  mlfScalar(2.0))));
        /*
         * elseif iorder==5
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(5.0)))) {
            /*
             * z=[-0.430575 -0.0430963];
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 2, __Array5_r, NULL));
            /*
             * c0=(1-z(1))*(1-z(2))^2 ;
             */
            mlfAssign(
              &c0,
              mlfMtimes(
                mlfMinus(mlfScalar(1.0), mlfIndexRef(z, "(?)", mlfScalar(1.0))),
                mlfMpower(
                  mlfMinus(
                    mlfScalar(1.0), mlfIndexRef(z, "(?)", mlfScalar(2.0))),
                  mlfScalar(2.0))));
        /*
         * elseif iorder==6
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(6.0)))) {
            /*
             * z=[-0.488295 -0.0816793 -0.00141415];
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 3, __Array6_r, NULL));
            /*
             * c0=2.598975999348577818390170516255374207847876 ;
             */
            mlfAssign(
              &c0, mlfScalar(2.598975999348577818390170516255374207847876));
        /*
         * elseif iorder==7
         */
        } else if (mlfTobool(mlfEq(iorder, mlfScalar(7.0)))) {
            /*
             * z=[-0.53528 -0.122555 -0.00914869];
             */
            mlfAssign(&z, mlfDoubleMatrix(1, 3, __Array7_r, NULL));
            /*
             * c0= 3.02482820364418438867954638323057821469168786155 ;
             */
            mlfAssign(
              &c0,
              mlfScalar(3.02482820364418438867954638323057821469168786155));
        /*
         * else
         */
        } else {
            /*
             * error('Order not available')
             */
            mlfError(mxCreateString("Order not available"));
            /*
             * return
             */
            goto return_;
        /*
         * end
         */
        }
    /*
     * 
     * end ;  
     */
    }
    /*
     * 
     * y=filiirs(x,z,c0);
     */
    mlfAssign(&y, mlfNFiliirs(0, mclValueVarargout(), x, z, c0, NULL));
    return_:
    mclValidateOutputs("fspline", 1, nargout_, &y);
    mxDestroyArray(c0);
    mxDestroyArray(z);
    return y;
}

/*
 * The function "mlfFspline" contains the normal interface for the "fspline"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/fspline.m" (lines
 * 1-81). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfFspline(mxArray * x, mxArray * iorder) {
    int nargout = 1;
    mxArray * y = mclGetUninitializedArray();
    mlfEnterNewContext(0, 2, x, iorder);
    y = Mfspline(nargout, x, iorder);
    mlfRestorePreviousContext(0, 2, x, iorder);
    return mlfReturnValue(y);
}

/*
 * The function "mlxFspline" contains the feval interface for the "fspline"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/fspline.m" (lines
 * 1-81). The feval function calls the implementation version of fspline
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxFspline(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fspline Line: 1 Column: "
            "0 The function \"fspline\" was called with mor"
            "e than the declared number of outputs (1)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fspline Line: 1 Column:"
            " 0 The function \"fspline\" was called with m"
            "ore than the declared number of inputs (2)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mfspline(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}
