/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:49:35 1999
 * Arguments: "-x" "-h" "lndradimg.m" 
 */
#include "fsplinem.h"
#include "fspline.h"

/*
 * The function "Mfsplinem" is the implementation version of the "fsplinem"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/fsplinem.m" (lines
 * 1-48). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function c=fsplinem(x,order) ;
 */
static mxArray * Mfsplinem(int nargout_, mxArray * x, mxArray * order) {
    mxArray * c = mclGetUninitializedArray();
    mxArray * N = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mxArray * i1 = mclGetUninitializedArray();
    mxArray * i2 = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mclForLoopIterator iterator_1;
    mxArray * s = mclGetUninitializedArray();
    mclValidateInputs("fsplinem", 2, &x, &order);
    /*
     * % Returns B-spline coefficients of a multidimensional array
     * % Applies fspline along all dimensions of a multidimensional array
     * % Mirror boundary conditions
     * %
     * % Usage: c=fsplinem(x,order) ;
     * %
     * % $Id: fsplinem.m,v 1.2 1999/09/10 20:05:21 jkybic Exp $
     * % Jan Kybic, 1999
     * 
     * N=ndims(x) ;
     */
    mlfAssign(&N, mlfNdims(x));
    /*
     * 
     * s=size(x) ;
     */
    mlfAssign(&s, mlfSize(mclValueVarargout(), x, NULL));
    /*
     * 
     * if N==2 & ( s(1)==1 | s(2)==1 ), % unidimensional x
     */
    {
        mxArray * a_ = mclInitialize(mlfEq(N, mlfScalar(2.0)));
        if (mlfTobool(a_)) {
            mxArray * b_ = mclInitialize(
                             mlfEq(
                               mlfIndexRef(s, "(?)", mlfScalar(1.0)),
                               mlfScalar(1.0)));
            if (mlfTobool(b_)) {
                mlfAssign(&b_, mlfScalar(1));
            } else {
                mlfAssign(
                  &b_,
                  mlfOr(
                    b_,
                    mlfEq(
                      mlfIndexRef(s, "(?)", mlfScalar(2.0)), mlfScalar(1.0))));
            }
            {
                int c_0 = mlfTobool(mlfAnd(a_, b_));
                mxDestroyArray(b_);
                mxDestroyArray(a_);
                if (c_0) {
                    /*
                     * N=1 ;
                     */
                    mlfAssign(&N, mlfScalar(1.0));
                }
            }
        /*
         * end ;
         */
        } else {
            mxDestroyArray(a_);
        }
    }
    /*
     * 
     * switch N
     * case 1,
     */
    if (mclSwitchCompare(N, mlfScalar(1.0))) {
        /*
         * c=fspline(x,order) ;
         */
        mlfAssign(&c, mlfFspline(x, order));
    /*
     * case 2,
     */
    } else if (mclSwitchCompare(N, mlfScalar(2.0))) {
        /*
         * for i=1:s(1),
         */
        for (mclForStart(
               &iterator_0,
               mlfScalar(1.0),
               mlfIndexRef(s, "(?)", mlfScalar(1.0)),
               NULL);
             mclForNext(&iterator_0, &i);
             ) {
            /*
             * c(i,:)=fspline(x(i,:),order) ;
             */
            mlfIndexAssign(
              &c,
              "(?,?)",
              i,
              mlfCreateColonIndex(),
              mlfFspline(
                mlfIndexRef(x, "(?,?)", i, mlfCreateColonIndex()), order));
        /*
         * end ;
         */
        }
        /*
         * for i=1:s(2),
         */
        for (mclForStart(
               &iterator_0,
               mlfScalar(1.0),
               mlfIndexRef(s, "(?)", mlfScalar(2.0)),
               NULL);
             mclForNext(&iterator_0, &i);
             ) {
            /*
             * c(:,i)=fspline(c(:,i),order) ;
             */
            mlfIndexAssign(
              &c,
              "(?,?)",
              mlfCreateColonIndex(),
              i,
              mlfFspline(
                mlfIndexRef(c, "(?,?)", mlfCreateColonIndex(), i), order));
        /*
         * end ;
         */
        }
    /*
     * case 3,
     */
    } else if (mclSwitchCompare(N, mlfScalar(3.0))) {
        /*
         * for i1=1:s(1),
         */
        for (mclForStart(
               &iterator_0,
               mlfScalar(1.0),
               mlfIndexRef(s, "(?)", mlfScalar(1.0)),
               NULL);
             mclForNext(&iterator_0, &i1);
             ) {
            /*
             * for i2=1:s(2),
             */
            for (mclForStart(
                   &iterator_1,
                   mlfScalar(1.0),
                   mlfIndexRef(s, "(?)", mlfScalar(2.0)),
                   NULL);
                 mclForNext(&iterator_1, &i2);
                 ) {
                /*
                 * c(i1,i2,:)=fspline(x(i1,i2,:),order) ;
                 */
                mlfIndexAssign(
                  &c,
                  "(?,?,?)",
                  i1,
                  i2,
                  mlfCreateColonIndex(),
                  mlfFspline(
                    mlfIndexRef(x, "(?,?,?)", i1, i2, mlfCreateColonIndex()),
                    order));
            /*
             * end ;
             */
            }
        /*
         * end ;
         */
        }
        /*
         * for i1=1:s(1),
         */
        for (mclForStart(
               &iterator_0,
               mlfScalar(1.0),
               mlfIndexRef(s, "(?)", mlfScalar(1.0)),
               NULL);
             mclForNext(&iterator_0, &i1);
             ) {
            /*
             * for i2=1:s(3),
             */
            for (mclForStart(
                   &iterator_1,
                   mlfScalar(1.0),
                   mlfIndexRef(s, "(?)", mlfScalar(3.0)),
                   NULL);
                 mclForNext(&iterator_1, &i2);
                 ) {
                /*
                 * c(i1,:,i2)=fspline(c(i1,:,i2),order) ;
                 */
                mlfIndexAssign(
                  &c,
                  "(?,?,?)",
                  i1,
                  mlfCreateColonIndex(),
                  i2,
                  mlfFspline(
                    mlfIndexRef(c, "(?,?,?)", i1, mlfCreateColonIndex(), i2),
                    order));
            /*
             * end ;
             */
            }
        /*
         * end ;
         */
        }
        /*
         * for i1=1:s(2),
         */
        for (mclForStart(
               &iterator_0,
               mlfScalar(1.0),
               mlfIndexRef(s, "(?)", mlfScalar(2.0)),
               NULL);
             mclForNext(&iterator_0, &i1);
             ) {
            /*
             * for i2=1:s(3),
             */
            for (mclForStart(
                   &iterator_1,
                   mlfScalar(1.0),
                   mlfIndexRef(s, "(?)", mlfScalar(3.0)),
                   NULL);
                 mclForNext(&iterator_1, &i2);
                 ) {
                /*
                 * c(:,i1,i2)=fspline(c(:,i1,i2),order) ;
                 */
                mlfIndexAssign(
                  &c,
                  "(?,?,?)",
                  mlfCreateColonIndex(),
                  i1,
                  i2,
                  mlfFspline(
                    mlfIndexRef(c, "(?,?,?)", mlfCreateColonIndex(), i1, i2),
                    order));
            /*
             * end ;
             */
            }
        /*
         * end ;
         */
        }
    /*
     * otherwise,
     */
    } else {
        /*
         * error('Sorry, dimensionality of x is not supported, probably too high') ;
         */
        mlfError(
          mxCreateString(
            "Sorry, dimensionality of x is not supported, probably too high"));
    /*
     * end ;    
     */
    }
    mclValidateOutputs("fsplinem", 1, nargout_, &c);
    mxDestroyArray(N);
    mxDestroyArray(i);
    mxDestroyArray(i1);
    mxDestroyArray(i2);
    mxDestroyArray(s);
    /*
     * 
     */
    return c;
}

/*
 * The function "mlfFsplinem" contains the normal interface for the "fsplinem"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/fsplinem.m" (lines
 * 1-48). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfFsplinem(mxArray * x, mxArray * order) {
    int nargout = 1;
    mxArray * c = mclGetUninitializedArray();
    mlfEnterNewContext(0, 2, x, order);
    c = Mfsplinem(nargout, x, order);
    mlfRestorePreviousContext(0, 2, x, order);
    return mlfReturnValue(c);
}

/*
 * The function "mlxFsplinem" contains the feval interface for the "fsplinem"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/fsplinem.m" (lines
 * 1-48). The feval function calls the implementation version of fsplinem
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxFsplinem(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fsplinem Line: 1 Column:"
            " 0 The function \"fsplinem\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fsplinem Line: 1 Column:"
            " 0 The function \"fsplinem\" was called with m"
            "ore than the declared number of inputs (2)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mfsplinem(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}
