/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:49:35 1999
 * Arguments: "-x" "-h" "lndradimg.m" 
 */
#include "lndradeval.h"

/*
 * The function "Mlndradeval" is the implementation version of the "lndradeval"
 * M-function from file "/home/jkybic/work/matlabsrc/landmarks/lndradeval.m"
 * (lines 1-24). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function w=lndradeval(p,x,c,alpha) ;
 */
static mxArray * Mlndradeval(int nargout_,
                             mxArray * p,
                             mxArray * x,
                             mxArray * c,
                             mxArray * alpha) {
    mxArray * w = mclGetUninitializedArray();
    mxArray * alphah = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * n = mclGetUninitializedArray();
    mxArray * r2 = mclGetUninitializedArray();
    mclValidateInputs("lndradeval", 4, &p, &x, &c, &alpha);
    /*
     * % Evaluate radial power function interpolation at (2D) point p given
     * % coefficients c 
     * % and landmark locations x
     * %
     * % Usage:  w=lndradeval(p,x,c,alpha) 
     * %
     * % $Id: lndthseval.m,v 1.1 1999/09/17 15:18:15 jkybic Exp $
     * % Jan Kybic, 1999
     * 
     * w=0 ;
     */
    mlfAssign(&w, mlfScalar(0.0));
    /*
     * n=length(c)-3 ;
     */
    mlfAssign(&n, mlfMinus(mlfLength(c), mlfScalar(3.0)));
    /*
     * alphah=alpha/2 ;
     */
    mlfAssign(&alphah, mlfMrdivide(alpha, mlfScalar(2.0)));
    /*
     * 
     * for i=1:n,
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), n, NULL);
         mclForNext(&iterator_0, &i);
         ) {
        /*
         * r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ;
         */
        mlfAssign(
          &r2,
          mlfPlus(
            mlfMpower(
              mlfMinus(
                mlfIndexRef(x, "(?,?)", i, mlfScalar(1.0)),
                mlfIndexRef(p, "(?)", mlfScalar(1.0))),
              mlfScalar(2.0)),
            mlfMpower(
              mlfMinus(
                mlfIndexRef(x, "(?,?)", i, mlfScalar(2.0)),
                mlfIndexRef(p, "(?)", mlfScalar(2.0))),
              mlfScalar(2.0))));
        /*
         * if r2>0,
         */
        if (mlfTobool(mlfGt(r2, mlfScalar(0.0)))) {
            /*
             * w=w+c(i)*r2^alphah ; % actually twice as much as r^2 ln(r) 
             */
            mlfAssign(
              &w,
              mlfPlus(
                w, mlfMtimes(mlfIndexRef(c, "(?)", i), mlfMpower(r2, alphah))));
        /*
         * end ;
         */
        }
    /*
     * end ;
     */
    }
    /*
     * 
     * w=w+c(n+1)*p(1)+c(n+2)*p(2)+c(n+3) ;
     */
    mlfAssign(
      &w,
      mlfPlus(
        mlfPlus(
          mlfPlus(
            w,
            mlfMtimes(
              mlfIndexRef(c, "(?)", mlfPlus(n, mlfScalar(1.0))),
              mlfIndexRef(p, "(?)", mlfScalar(1.0)))),
          mlfMtimes(
            mlfIndexRef(c, "(?)", mlfPlus(n, mlfScalar(2.0))),
            mlfIndexRef(p, "(?)", mlfScalar(2.0)))),
        mlfIndexRef(c, "(?)", mlfPlus(n, mlfScalar(3.0)))));
    mclValidateOutputs("lndradeval", 1, nargout_, &w);
    mxDestroyArray(alphah);
    mxDestroyArray(i);
    mxDestroyArray(n);
    mxDestroyArray(r2);
    /*
     * 
     */
    return w;
}

/*
 * The function "mlfLndradeval" contains the normal interface for the
 * "lndradeval" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndradeval.m" (lines 1-24). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfLndradeval(mxArray * p,
                        mxArray * x,
                        mxArray * c,
                        mxArray * alpha) {
    int nargout = 1;
    mxArray * w = mclGetUninitializedArray();
    mlfEnterNewContext(0, 4, p, x, c, alpha);
    w = Mlndradeval(nargout, p, x, c, alpha);
    mlfRestorePreviousContext(0, 4, p, x, c, alpha);
    return mlfReturnValue(w);
}

/*
 * The function "mlxLndradeval" contains the feval interface for the
 * "lndradeval" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndradeval.m" (lines 1-24). The feval
 * function calls the implementation version of lndradeval through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxLndradeval(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndradeval Line: 1 Column:"
            " 0 The function \"lndradeval\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndradeval Line: 1 Column"
            ": 0 The function \"lndradeval\" was called with"
            " more than the declared number of inputs (4)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Mlndradeval(nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
}
