/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:49:35 1999
 * Arguments: "-x" "-h" "lndradimg.m" 
 */
#include "lndradimg.h"
#include "fsplinem.h"
#include "lndradcoef.h"
#include "lndradeval.h"
#include "mexsplninterp.h"

/*
 * The function "Mlndradimg" is the implementation version of the "lndradimg"
 * M-function from file "/home/jkybic/work/matlabsrc/landmarks/lndradimg.m"
 * (lines 1-30). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function w=lndradimg(img,x,z,alpha) ;
 */
static mxArray * Mlndradimg(int nargout_,
                            mxArray * img,
                            mxArray * x,
                            mxArray * z,
                            mxArray * alpha) {
    mxArray * w = mclGetUninitializedArray();
    mxArray * cx = mclGetUninitializedArray();
    mxArray * cy = mclGetUninitializedArray();
    mxArray * f = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mclForLoopIterator iterator_1;
    mxArray * j = mclGetUninitializedArray();
    mxArray * nx = mclGetUninitializedArray();
    mxArray * ny = mclGetUninitializedArray();
    mxArray * tab = mclGetUninitializedArray();
    mclValidateInputs("lndradimg", 4, &img, &x, &z, &alpha);
    mclCopyArray(&x);
    mclCopyArray(&z);
    /*
     * % Warp image moving landmarks from points z in img to point x,
     * % interpolating in-between. Input coordinates expected in 
     * % Matlab ordering. Using radial power functions.
     * %
     * % Usage: w=lndradimg(img,x,z,alpha) ;
     * %
     * % Jan Kybic, 1999
     * %
     * % $Id: lndradimg.m,v 1.1 1999/09/28 15:36:57 jkybic Exp $
     * 
     * [ny,nx]=size(img) ;
     */
    mlfSize(mlfVarargout(&ny, &nx, NULL), img, NULL);
    /*
     * x=[ x(:,2) x(:,1) ]-1 ; % rearrange from Matlab conventions
     */
    mlfAssign(
      &x,
      mlfMinus(
        mlfHorzcat(
          mlfIndexRef(x, "(?,?)", mlfCreateColonIndex(), mlfScalar(2.0)),
          mlfIndexRef(x, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0)),
          NULL),
        mlfScalar(1.0)));
    /*
     * z=[ z(:,2) z(:,1) ]-1 ;
     */
    mlfAssign(
      &z,
      mlfMinus(
        mlfHorzcat(
          mlfIndexRef(z, "(?,?)", mlfCreateColonIndex(), mlfScalar(2.0)),
          mlfIndexRef(z, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0)),
          NULL),
        mlfScalar(1.0)));
    /*
     * disp('Calculating coefficients') ;
     */
    mlfDisp(mxCreateString("Calculating coefficients"));
    /*
     * cx=lndradcoef(x,z(:,1),alpha) ;
     */
    mlfAssign(
      &cx,
      mlfLndradcoef(
        x,
        mlfIndexRef(z, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0)),
        alpha));
    /*
     * cy=lndradcoef(x,z(:,2),alpha) ;
     */
    mlfAssign(
      &cy,
      mlfLndradcoef(
        x,
        mlfIndexRef(z, "(?,?)", mlfCreateColonIndex(), mlfScalar(2.0)),
        alpha));
    /*
     * disp('Bspline transform') ;
     */
    mlfDisp(mxCreateString("Bspline transform"));
    /*
     * f=fsplinem(img,3) ; 
     */
    mlfAssign(&f, mlfFsplinem(img, mlfScalar(3.0)));
    /*
     * disp('Generating table') ;
     */
    mlfDisp(mxCreateString("Generating table"));
    /*
     * tab=zeros(2,ny,nx) ;
     */
    mlfAssign(&tab, mlfZeros(mlfScalar(2.0), ny, nx, NULL));
    /*
     * for i=1:nx,
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), nx, NULL);
         mclForNext(&iterator_0, &i);
         ) {
        /*
         * for j=1:ny,
         */
        for (mclForStart(&iterator_1, mlfScalar(1.0), ny, NULL);
             mclForNext(&iterator_1, &j);
             ) {
            /*
             * tab(:,j,i)=[ lndradeval([j i],x,cx,alpha)  lndradeval([j i],x,cy,alpha) ] ; 
             */
            mlfIndexAssign(
              &tab,
              "(?,?,?)",
              mlfCreateColonIndex(),
              j,
              i,
              mlfHorzcat(
                mlfLndradeval(mlfHorzcat(j, i, NULL), x, cx, alpha),
                mlfLndradeval(mlfHorzcat(j, i, NULL), x, cy, alpha),
                NULL));
        /*
         * end ;
         */
        }
    /*
     * end ;
     */
    }
    /*
     * disp('Warping') ;  
     */
    mlfDisp(mxCreateString("Warping"));
    /*
     * w=mexsplninterp(f,tab,2,3) ;
     */
    mlfAssign(
      &w,
      mlfNMexsplninterp(
        0, mclValueVarargout(), f, tab, mlfScalar(2.0), mlfScalar(3.0), NULL));
    /*
     * disp('Finished') ;
     */
    mlfDisp(mxCreateString("Finished"));
    mclValidateOutputs("lndradimg", 1, nargout_, &w);
    mxDestroyArray(cx);
    mxDestroyArray(cy);
    mxDestroyArray(f);
    mxDestroyArray(i);
    mxDestroyArray(j);
    mxDestroyArray(nx);
    mxDestroyArray(ny);
    mxDestroyArray(tab);
    mxDestroyArray(x);
    mxDestroyArray(z);
    return w;
}

/*
 * The function "mlfLndradimg" contains the normal interface for the
 * "lndradimg" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndradimg.m" (lines 1-30). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfLndradimg(mxArray * img,
                       mxArray * x,
                       mxArray * z,
                       mxArray * alpha) {
    int nargout = 1;
    mxArray * w = mclGetUninitializedArray();
    mlfEnterNewContext(0, 4, img, x, z, alpha);
    w = Mlndradimg(nargout, img, x, z, alpha);
    mlfRestorePreviousContext(0, 4, img, x, z, alpha);
    return mlfReturnValue(w);
}

/*
 * The function "mlxLndradimg" contains the feval interface for the "lndradimg"
 * M-function from file "/home/jkybic/work/matlabsrc/landmarks/lndradimg.m"
 * (lines 1-30). The feval function calls the implementation version of
 * lndradimg through this function. This function processes any input arguments
 * and passes them to the implementation version of the function, appearing
 * above.
 */
void mlxLndradimg(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndradimg Line: 1 Column:"
            " 0 The function \"lndradimg\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndradimg Line: 1 Column:"
            " 0 The function \"lndradimg\" was called with m"
            "ore than the declared number of inputs (4)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Mlndradimg(nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
}
