/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:48:47 1999
 * Arguments: "-x" "-h" "lndthsimg.m" 
 */
#include "lndthscoef.h"

static double __Array0_r[1] = { 0.0 };

static double __Array1_r[1] = { 0.0 };

static double __Array2_r[1] = { 0.0 };

/*
 * The function "Mlndthscoef" is the implementation version of the "lndthscoef"
 * M-function from file "/home/jkybic/work/matlabsrc/landmarks/lndthscoef.m"
 * (lines 1-38). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function c=lndthscoef(x,z) ;
 */
static mxArray * Mlndthscoef(int nargout_, mxArray * x, mxArray * z) {
    mxArray * c = mclGetUninitializedArray();
    mxArray * A = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mclForLoopIterator iterator_1;
    mxArray * j = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * q = mclGetUninitializedArray();
    mxArray * r2 = mclGetUninitializedArray();
    mxArray * s = mclGetUninitializedArray();
    mxArray * u = mclGetUninitializedArray();
    mxArray * v = mclGetUninitializedArray();
    mclValidateInputs("lndthscoef", 2, &x, &z);
    /*
     * % Calculate coefficients for thin-plate spline interpolation
     * % Calculates coefficients (usable e.g. by lndthseval) to interpolate
     * % function having values z at points x
     * %
     * % Usage: c=lndthscoef(x,z) 
     * %
     * % $Id: lndthscoef.m,v 1.1 1999/09/17 15:18:15 jkybic Exp $
     * % Jan Kybic, 1999
     * 
     * n=length(z) ;
     */
    mlfAssign(&n, mlfLength(z));
    /*
     * A=zeros(n+3) ;
     */
    mlfAssign(&A, mlfZeros(mlfPlus(n, mlfScalar(3.0)), NULL));
    /*
     * 
     * for i=1:n,
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), n, NULL);
         mclForNext(&iterator_0, &i);
         ) {
        /*
         * for j=1:n,
         */
        for (mclForStart(&iterator_1, mlfScalar(1.0), n, NULL);
             mclForNext(&iterator_1, &j);
             ) {
            /*
             * r2=(x(i,1)-x(j,1))^2+(x(i,2)-x(j,2))^2 ;
             */
            mlfAssign(
              &r2,
              mlfPlus(
                mlfMpower(
                  mlfMinus(
                    mlfIndexRef(x, "(?,?)", i, mlfScalar(1.0)),
                    mlfIndexRef(x, "(?,?)", j, mlfScalar(1.0))),
                  mlfScalar(2.0)),
                mlfMpower(
                  mlfMinus(
                    mlfIndexRef(x, "(?,?)", i, mlfScalar(2.0)),
                    mlfIndexRef(x, "(?,?)", j, mlfScalar(2.0))),
                  mlfScalar(2.0))));
            /*
             * if r2==0,
             */
            if (mlfTobool(mlfEq(r2, mlfScalar(0.0)))) {
                /*
                 * A(i,j)=0 ;
                 */
                mlfIndexAssign(&A, "(?,?)", i, j, mlfScalar(0.0));
            /*
             * else
             */
            } else {
                /*
                 * A(i,j)=r2*log(r2) ; % actually twice as much as r^2 ln(r) 
                 */
                mlfIndexAssign(&A, "(?,?)", i, j, mlfMtimes(r2, mlfLog(r2)));
            /*
             * end ;
             */
            }
        /*
         * end ;
         */
        }
        /*
         * A(i,n+1:n+3)=[ x(i,1:2) 1 ] ; 
         */
        mlfIndexAssign(
          &A,
          "(?,?)",
          i,
          mlfColon(
            mlfPlus(n, mlfScalar(1.0)), mlfPlus(n, mlfScalar(3.0)), NULL),
          mlfHorzcat(
            mlfIndexRef(
              x, "(?,?)", i, mlfColon(mlfScalar(1.0), mlfScalar(2.0), NULL)),
            mlfScalar(1.0),
            NULL));
    /*
     * end ;
     */
    }
    /*
     * 
     * A(n+1,1:n)=x(:,1)' ;
     */
    mlfIndexAssign(
      &A,
      "(?,?)",
      mlfPlus(n, mlfScalar(1.0)),
      mlfColon(mlfScalar(1.0), n, NULL),
      mlfCtranspose(
        mlfIndexRef(x, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0))));
    /*
     * A(n+2,1:n)=x(:,2)' ;
     */
    mlfIndexAssign(
      &A,
      "(?,?)",
      mlfPlus(n, mlfScalar(2.0)),
      mlfColon(mlfScalar(1.0), n, NULL),
      mlfCtranspose(
        mlfIndexRef(x, "(?,?)", mlfCreateColonIndex(), mlfScalar(2.0))));
    /*
     * A(n+3,1:n)=ones(1,n) ;
     */
    mlfIndexAssign(
      &A,
      "(?,?)",
      mlfPlus(n, mlfScalar(3.0)),
      mlfColon(mlfScalar(1.0), n, NULL),
      mlfOnes(mlfScalar(1.0), n, NULL));
    /*
     * 
     * % Solve using SVD techniques
     * [u,s,v]=svd(A) ;
     */
    mlfAssign(&u, mlfSvd(&s, &v, A, NULL));
    /*
     * s=diag(s) ; q=(s(1)*1e-6+1e-50) ;
     */
    mlfAssign(&s, mlfDiag(s, NULL));
    mlfAssign(
      &q,
      mlfPlus(
        mlfMtimes(mlfIndexRef(s, "(?)", mlfScalar(1.0)), mlfScalar(1e-6)),
        mlfScalar(1e-50)));
    /*
     * for i=1:n+3,
     */
    for (mclForStart(
           &iterator_0, mlfScalar(1.0), mlfPlus(n, mlfScalar(3.0)), NULL);
         mclForNext(&iterator_0, &i);
         ) {
        /*
         * if s(i)<q, s(i)=0 ; 
         */
        if (mlfTobool(mlfLt(mlfIndexRef(s, "(?)", i), q))) {
            mlfIndexAssign(&s, "(?)", i, mlfScalar(0.0));
        /*
         * else s(i)=1/s(i) ; end ;
         */
        } else {
            mlfIndexAssign(
              &s,
              "(?)",
              i,
              mlfMrdivide(mlfScalar(1.0), mlfIndexRef(s, "(?)", i)));
        }
    /*
     * end ;
     */
    }
    /*
     * 
     * c=v*diag(s)*u'*[z(:) ; 0 ; 0 ; 0 ] ;
     */
    mlfAssign(
      &c,
      mlfMtimes(
        mlfMtimes(mlfMtimes(v, mlfDiag(s, NULL)), mlfCtranspose(u)),
        mlfVertcat(
          mlfHorzcat(mlfIndexRef(z, "(?)", mlfCreateColonIndex()), NULL),
          mlfDoubleMatrix(1, 1, __Array0_r, NULL),
          mlfDoubleMatrix(1, 1, __Array1_r, NULL),
          mlfDoubleMatrix(1, 1, __Array2_r, NULL),
          NULL)));
    mclValidateOutputs("lndthscoef", 1, nargout_, &c);
    mxDestroyArray(A);
    mxDestroyArray(i);
    mxDestroyArray(j);
    mxDestroyArray(n);
    mxDestroyArray(q);
    mxDestroyArray(r2);
    mxDestroyArray(s);
    mxDestroyArray(u);
    mxDestroyArray(v);
    return c;
}

/*
 * The function "mlfLndthscoef" contains the normal interface for the
 * "lndthscoef" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndthscoef.m" (lines 1-38). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfLndthscoef(mxArray * x, mxArray * z) {
    int nargout = 1;
    mxArray * c = mclGetUninitializedArray();
    mlfEnterNewContext(0, 2, x, z);
    c = Mlndthscoef(nargout, x, z);
    mlfRestorePreviousContext(0, 2, x, z);
    return mlfReturnValue(c);
}

/*
 * The function "mlxLndthscoef" contains the feval interface for the
 * "lndthscoef" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndthscoef.m" (lines 1-38). The feval
 * function calls the implementation version of lndthscoef through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxLndthscoef(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndthscoef Line: 1 Column:"
            " 0 The function \"lndthscoef\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndthscoef Line: 1 Column"
            ": 0 The function \"lndthscoef\" was called with"
            " more than the declared number of inputs (2)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mlndthscoef(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}
