/*
 * MATLAB Compiler: 2.0
 * Date: Wed Sep 29 13:48:47 1999
 * Arguments: "-x" "-h" "lndthsimg.m" 
 */
#include "lndthseval.h"

/*
 * The function "Mlndthseval" is the implementation version of the "lndthseval"
 * M-function from file "/home/jkybic/work/matlabsrc/landmarks/lndthseval.m"
 * (lines 1-22). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function w=lndthseval(p,x,c) ;
 */
static mxArray * Mlndthseval(int nargout_,
                             mxArray * p,
                             mxArray * x,
                             mxArray * c) {
    mxArray * w = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * n = mclGetUninitializedArray();
    mxArray * r2 = mclGetUninitializedArray();
    mclValidateInputs("lndthseval", 3, &p, &x, &c);
    /*
     * % Evaluate a thin-plate spline at (2D) point p given coefficients c
     * % and landmark locations x
     * %
     * % Usage:  w=lndthseval(p,x,c) 
     * %
     * % $Id: lndthseval.m,v 1.1 1999/09/17 15:18:15 jkybic Exp $
     * % Jan Kybic, 1999
     * 
     * w=0 ;
     */
    mlfAssign(&w, mlfScalar(0.0));
    /*
     * n=length(c)-3 ;
     */
    mlfAssign(&n, mlfMinus(mlfLength(c), mlfScalar(3.0)));
    /*
     * 
     * for i=1:n,
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), n, NULL);
         mclForNext(&iterator_0, &i);
         ) {
        /*
         * r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ;
         */
        mlfAssign(
          &r2,
          mlfPlus(
            mlfMpower(
              mlfMinus(
                mlfIndexRef(x, "(?,?)", i, mlfScalar(1.0)),
                mlfIndexRef(p, "(?)", mlfScalar(1.0))),
              mlfScalar(2.0)),
            mlfMpower(
              mlfMinus(
                mlfIndexRef(x, "(?,?)", i, mlfScalar(2.0)),
                mlfIndexRef(p, "(?)", mlfScalar(2.0))),
              mlfScalar(2.0))));
        /*
         * if r2>0,
         */
        if (mlfTobool(mlfGt(r2, mlfScalar(0.0)))) {
            /*
             * w=w+c(i)*r2*log(r2) ; % actually twice as much as r^2 ln(r) 
             */
            mlfAssign(
              &w,
              mlfPlus(
                w,
                mlfMtimes(
                  mlfMtimes(mlfIndexRef(c, "(?)", i), r2), mlfLog(r2))));
        /*
         * end ;
         */
        }
    /*
     * end ;
     */
    }
    /*
     * 
     * w=w+c(n+1)*p(1)+c(n+2)*p(2)+c(n+3) ;
     */
    mlfAssign(
      &w,
      mlfPlus(
        mlfPlus(
          mlfPlus(
            w,
            mlfMtimes(
              mlfIndexRef(c, "(?)", mlfPlus(n, mlfScalar(1.0))),
              mlfIndexRef(p, "(?)", mlfScalar(1.0)))),
          mlfMtimes(
            mlfIndexRef(c, "(?)", mlfPlus(n, mlfScalar(2.0))),
            mlfIndexRef(p, "(?)", mlfScalar(2.0)))),
        mlfIndexRef(c, "(?)", mlfPlus(n, mlfScalar(3.0)))));
    mclValidateOutputs("lndthseval", 1, nargout_, &w);
    mxDestroyArray(i);
    mxDestroyArray(n);
    mxDestroyArray(r2);
    /*
     * 
     */
    return w;
}

/*
 * The function "mlfLndthseval" contains the normal interface for the
 * "lndthseval" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndthseval.m" (lines 1-22). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfLndthseval(mxArray * p, mxArray * x, mxArray * c) {
    int nargout = 1;
    mxArray * w = mclGetUninitializedArray();
    mlfEnterNewContext(0, 3, p, x, c);
    w = Mlndthseval(nargout, p, x, c);
    mlfRestorePreviousContext(0, 3, p, x, c);
    return mlfReturnValue(w);
}

/*
 * The function "mlxLndthseval" contains the feval interface for the
 * "lndthseval" M-function from file
 * "/home/jkybic/work/matlabsrc/landmarks/lndthseval.m" (lines 1-22). The feval
 * function calls the implementation version of lndthseval through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxLndthseval(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndthseval Line: 1 Column:"
            " 0 The function \"lndthseval\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lndthseval Line: 1 Column"
            ": 0 The function \"lndthseval\" was called with"
            " more than the declared number of inputs (3)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mlndthseval(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}
