static char mc_version[] = "MATLAB Compiler 1.2.1 Jan 21 1999 infun";
/*
 *  MATLAB Compiler: 1.2.1
 *  Date: Jan 21 1999
 *  Arguments: -v -Z -i -r privsdcgr 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 * M-File: /home/jkybic/work/matlabsrc/spline/privsdcgr.m
 *
 *       H           	real vector/matrix
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       cnum        	integer scalar
 *       dcell       	real vector/matrix
 *       dfc         	real vector/matrix
 *       dfddc       	real vector/matrix
 *       dsplftd     	real vector/matrix
 *       dsplftdd    	real vector/matrix
 *       e           	real vector/matrix
 *       ftd         	real vector/matrix
 *       ftdd        	real vector/matrix
 *       gr          	real vector/matrix
 *       i           	integer scalar
 *       imcnt       	integer scalar
 *       j           	integer scalar
 *       ndim        	real scalar
 *       privsdcgr   	<function being defined>
 *       reshape     	<function>
 *       sum         	<function>
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   

   if (nrhs_ > 7 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 2 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   mcmSetLineNumber(0);
   {
      mxArray gr;
      mxArray H;
      mxArray e;
      mxArray dcell;
      mxArray ftd;
      mxArray ftdd;
      int cnum = 0;
      int cnum_set_ = 0;
      double ndim = 0.0;
      int ndim_set_ = 0;
      int imcnt = 0;
      int imcnt_set_ = 0;
      mxArray dfc;
      mxArray dfddc;
      int i = 0;
      mxArray dsplftd;
      int j = 0;
      mxArray dsplftdd;
      int I0_ = 0;
      mxArray RM0_;
      mxArray RM1_;
      double R0_ = 0.0;
      int I1_ = 0;
      double R1_ = 0.0;
      
      mccRealInit(e);
      mccImport(&e, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(dcell);
      mccImport(&dcell, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(ftd);
      mccImport(&ftd, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(ftdd);
      mccImport(&ftdd, ((nrhs_>3) ? prhs_[3] : 0), 0, 0);
      cnum = mccImportReal(&cnum_set_, 0, (mxArray *) ((nrhs_>4) ? prhs_[4] : 0), 0, "cnum");
      ndim = mccImportReal(&ndim_set_, 0, (mxArray *) ((nrhs_>5) ? prhs_[5] : 0), 0, "ndim");
      imcnt = mccImportReal(&imcnt_set_, 0, (mxArray *) ((nrhs_>6) ? prhs_[6] : 0), 0, "imcnt");
      mccRealInit(gr);
      mccRealInit(H);
      mccRealInit(dfc);
      mccRealInit(dfddc);
      mccRealInit(dsplftd);
      mccRealInit(dsplftdd);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      
      /* % Private executable part of sdcgr, just so that it is compilable */
      
      /* % $Id: privsdcgr.m,v 1.1 1999/11/19 14:13:44 jkybic Exp $ */
      /* % Jan Kybic, 1999 */
      
      /* H=zeros(cnum,cnum) ; % the future Hessian matrix */
      if( !cnum_set_ )
      {
         mexErrMsgTxt( "variable cnum undefined, line 7" );
      }
      mccZerosMN(&H, cnum, cnum);
      mccLOG(&H) = 0;
      mccSTRING(&H) = 0;
      /* gr=zeros(cnum,1) ; */
      mccZerosMN(&gr, cnum, 1);
      mccLOG(&gr) = 0;
      mccSTRING(&gr) = 0;
      
      /* dfc=zeros(imcnt*ndim,cnum) ; */
      if( !imcnt_set_ )
      {
         mexErrMsgTxt( "variable imcnt undefined, line 10" );
      }
      if( !ndim_set_ )
      {
         mexErrMsgTxt( "variable ndim undefined, line 10" );
      }
      mccZerosMN(&dfc, ((int)(imcnt * (double) ndim)), cnum);
      /* dfddc=zeros(imcnt*ndim,cnum) ; */
      mccZerosMN(&dfddc, ((int)(imcnt * (double) ndim)), cnum);
      /* for i=1:cnum, % for all parameters c */
      for (I0_ = 1; I0_ <= cnum; I0_ = I0_ + 1)
      {
         i = I0_;
         /* dfc(:,i)=dcell(:,i).*ftd ; */
         if(mccNOTSET(&dcell))
         {
            mexErrMsgTxt( "variable dcell undefined, line 13" );
         }
         if(mccNOTSET(&ftd))
         {
            mexErrMsgTxt( "variable ftd undefined, line 13" );
         }
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_dfc;
            int I_dfc=1, J_dfc;
            double *p_dcell;
            int I_dcell=1, J_dcell;
            double *p_ftd;
            int I_ftd=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&dcell), 1);
            m_ = mcmCalcResultSize(m_, &n_, mccM(&ftd), mccN(&ftd));
            if (!mccNOTSET(&dfc)) m_ = mcmCalcResultSize(m_, &n_, mccM(&dfc), 1);
            if (mccM(&dfc) == 1) { I_dfc = J_dfc = 0;}
            else { I_dfc = 1; J_dfc=mccM(&dfc)-m_; }
            p_dfc = mccPR(&dfc) + 0 + mccM(&dfc) * (i-1);
            if (mccM(&dcell) == 1) { I_dcell = J_dcell = 0;}
            else { I_dcell = 1; J_dcell=mccM(&dcell)-m_; }
            p_dcell = mccPR(&dcell) + 0 + mccM(&dcell) * (i-1);
            I_ftd = (mccM(&ftd) != 1 || mccN(&ftd) != 1);
            p_ftd = mccPR(&ftd);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_dfc += J_dfc, p_dcell += J_dcell)
               {
                  for (i_=0; i_<m_; ++i_, p_dfc+=I_dfc, p_dcell+=I_dcell, p_ftd+=I_ftd)
                  {
                     *p_dfc = (*p_dcell * (double) *p_ftd);
                  }
               }
            }
         }
         /* dfddc(:,i)=dcell(:,i).*ftdd ; */
         if(mccNOTSET(&ftdd))
         {
            mexErrMsgTxt( "variable ftdd undefined, line 14" );
         }
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_dfddc;
            int I_dfddc=1, J_dfddc;
            double *p_dcell;
            int I_dcell=1, J_dcell;
            double *p_ftdd;
            int I_ftdd=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&dcell), 1);
            m_ = mcmCalcResultSize(m_, &n_, mccM(&ftdd), mccN(&ftdd));
            if (!mccNOTSET(&dfddc)) m_ = mcmCalcResultSize(m_, &n_, mccM(&dfddc), 1);
            if (mccM(&dfddc) == 1) { I_dfddc = J_dfddc = 0;}
            else { I_dfddc = 1; J_dfddc=mccM(&dfddc)-m_; }
            p_dfddc = mccPR(&dfddc) + 0 + mccM(&dfddc) * (i-1);
            if (mccM(&dcell) == 1) { I_dcell = J_dcell = 0;}
            else { I_dcell = 1; J_dcell=mccM(&dcell)-m_; }
            p_dcell = mccPR(&dcell) + 0 + mccM(&dcell) * (i-1);
            I_ftdd = (mccM(&ftdd) != 1 || mccN(&ftdd) != 1);
            p_ftdd = mccPR(&ftdd);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_dfddc += J_dfddc, p_dcell += J_dcell)
               {
                  for (i_=0; i_<m_; ++i_, p_dfddc+=I_dfddc, p_dcell+=I_dcell, p_ftdd+=I_ftdd)
                  {
                     *p_dfddc = (*p_dcell * (double) *p_ftdd);
                  }
               }
            }
         }
         /* if ndim==1, */
         if (( (ndim == 1) && !mccREL_NAN(ndim) ))
         {
            /* gr(i)=2*sum(e.*dfc(:,i)) ; */
            if(mccNOTSET(&e))
            {
               mexErrMsgTxt( "variable e undefined, line 16" );
            }
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_RM0_;
               int I_RM0_=1;
               double *p_e;
               int I_e=1;
               double *p_dfc;
               int I_dfc=1, J_dfc;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&e), mccN(&e));
               m_ = mcmCalcResultSize(m_, &n_, mccM(&dfc), 1);
               mccAllocateMatrix(&RM0_, m_, n_);
               I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
               p_RM0_ = mccPR(&RM0_);
               I_e = (mccM(&e) != 1 || mccN(&e) != 1);
               p_e = mccPR(&e);
               if (mccM(&dfc) == 1) { I_dfc = J_dfc = 0;}
               else { I_dfc = 1; J_dfc=mccM(&dfc)-m_; }
               p_dfc = mccPR(&dfc) + 0 + mccM(&dfc) * (i-1);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_, p_dfc += J_dfc)
                  {
                     for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_e+=I_e, p_dfc+=I_dfc)
                     {
                        *p_RM0_ = (*p_e * (double) *p_dfc);
                     }
                  }
               }
            }
            mccSum(&RM1_, &RM0_);
            R0_ = (mccPR(&RM1_)[(1-1)]);
            mccPR(&gr)[(i-1)] = (2 * (double) R0_);
         }
         else
         {
            /* else */
            /* dsplftd=sum(reshape(dfc(:,i),ndim,imcnt)) ; */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_RM1_;
               int I_RM1_=1;
               double *p_dfc;
               int I_dfc=1, J_dfc;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&dfc), 1);
               mccAllocateMatrix(&RM1_, m_, n_);
               I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
               p_RM1_ = mccPR(&RM1_);
               if (mccM(&dfc) == 1) { I_dfc = J_dfc = 0;}
               else { I_dfc = 1; J_dfc=mccM(&dfc)-m_; }
               p_dfc = mccPR(&dfc) + 0 + mccM(&dfc) * (i-1);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_, p_dfc += J_dfc)
                  {
                     for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_dfc+=I_dfc)
                     {
                        *p_RM1_ = *p_dfc;
                     }
                  }
               }
            }
            mccSTRING(&RM1_) = 0;
            mccReshape(&RM0_, &RM1_, ((int)ndim), imcnt);
            mccSum(&dsplftd, &RM0_);
            /* gr(i)=2*(dsplftd*e) ; % scalar product */
            if(mccNOTSET(&e))
            {
               mexErrMsgTxt( "variable e undefined, line 19" );
            }
            R0_ = mccRealInnerProduct(&dsplftd, &e);
            mccPR(&gr)[(i-1)] = (2 * (double) R0_);
            /* end ; */
         }
         /* % Here we start with the Hessian calculation */
         /* for j=1:i, */
         for (I1_ = 1; I1_ <= i; I1_ = I1_ + 1)
         {
            j = I1_;
            /* if ndim==1, */
            if (( (ndim == 1) && !mccREL_NAN(ndim) ))
            {
               /* H(j+(i-1)*cnum)=2*sum(dcell(:,i).*dcell(:,j).*(ftd.^2+e.*ftdd)) ; */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM0_;
                  int I_RM0_=1;
                  double *p_dcell;
                  int I_dcell=1, J_dcell;
                  double *p_1dcell;
                  int I_1dcell=1, J_1dcell;
                  double *p_ftd;
                  int I_ftd=1;
                  double *p_e;
                  int I_e=1;
                  double *p_ftdd;
                  int I_ftdd=1;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&dcell), 1);
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&dcell), 1);
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&ftd), mccN(&ftd));
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&e), mccN(&e));
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&ftdd), mccN(&ftdd));
                  mccAllocateMatrix(&RM0_, m_, n_);
                  I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
                  p_RM0_ = mccPR(&RM0_);
                  if (mccM(&dcell) == 1) { I_dcell = J_dcell = 0;}
                  else { I_dcell = 1; J_dcell=mccM(&dcell)-m_; }
                  p_dcell = mccPR(&dcell) + 0 + mccM(&dcell) * (i-1);
                  if (mccM(&dcell) == 1) { I_1dcell = J_1dcell = 0;}
                  else { I_1dcell = 1; J_1dcell=mccM(&dcell)-m_; }
                  p_1dcell = mccPR(&dcell) + 0 + mccM(&dcell) * (j-1);
                  I_ftd = (mccM(&ftd) != 1 || mccN(&ftd) != 1);
                  p_ftd = mccPR(&ftd);
                  I_e = (mccM(&e) != 1 || mccN(&e) != 1);
                  p_e = mccPR(&e);
                  I_ftdd = (mccM(&ftdd) != 1 || mccN(&ftdd) != 1);
                  p_ftdd = mccPR(&ftdd);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_, p_dcell += J_dcell, p_1dcell += J_1dcell)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_dcell+=I_dcell, p_1dcell+=I_1dcell, p_ftd+=I_ftd, p_e+=I_e, p_ftdd+=I_ftdd)
                        {
                           *p_RM0_ = ((*p_dcell * (double) *p_1dcell) * (double) (mcmRealPowerInt(*p_ftd, 2) + (*p_e * (double) *p_ftdd)));
                        }
                     }
                  }
               }
               mccSum(&RM1_, &RM0_);
               R0_ = (mccPR(&RM1_)[(1-1)]);
               mccPR(&H)[((int)((j + ((i - 1) * (double) cnum))-.5))] = (2 * (double) R0_);
               /* H(i+(j-1)*cnum)=H(j+(i-1)*cnum) ; */
               mccPR(&H)[((int)((i + ((j - 1) * (double) cnum))-.5))] = (mccPR(&H)[((int)((j + ((i - 1) * (double) cnum))-.5))]);
            }
            else
            {
               /* else */
               /* dsplftd=sum(reshape(dfc(:,i).*dfc(:,j),ndim,imcnt)) ; */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM1_;
                  int I_RM1_=1;
                  double *p_dfc;
                  int I_dfc=1, J_dfc;
                  double *p_1dfc;
                  int I_1dfc=1, J_1dfc;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&dfc), 1);
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&dfc), 1);
                  mccAllocateMatrix(&RM1_, m_, n_);
                  I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
                  p_RM1_ = mccPR(&RM1_);
                  if (mccM(&dfc) == 1) { I_dfc = J_dfc = 0;}
                  else { I_dfc = 1; J_dfc=mccM(&dfc)-m_; }
                  p_dfc = mccPR(&dfc) + 0 + mccM(&dfc) * (i-1);
                  if (mccM(&dfc) == 1) { I_1dfc = J_1dfc = 0;}
                  else { I_1dfc = 1; J_1dfc=mccM(&dfc)-m_; }
                  p_1dfc = mccPR(&dfc) + 0 + mccM(&dfc) * (j-1);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_, p_dfc += J_dfc, p_1dfc += J_1dfc)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM1_+=I_RM1_, p_dfc+=I_dfc, p_1dfc+=I_1dfc)
                        {
                           *p_RM1_ = (*p_dfc * (double) *p_1dfc);
                        }
                     }
                  }
               }
               mccSTRING(&RM1_) = 0;
               mccReshape(&RM0_, &RM1_, ((int)ndim), imcnt);
               mccSum(&dsplftd, &RM0_);
               /* dsplftdd=sum(reshape(dfddc(:,i).*dcell(:,j),ndim,imcnt)) ; */
               {
                  int i_, j_;
                  int m_=1, n_=1, cx_ = 0;
                  double *p_RM0_;
                  int I_RM0_=1;
                  double *p_dfddc;
                  int I_dfddc=1, J_dfddc;
                  double *p_dcell;
                  int I_dcell=1, J_dcell;
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&dfddc), 1);
                  m_ = mcmCalcResultSize(m_, &n_, mccM(&dcell), 1);
                  mccAllocateMatrix(&RM0_, m_, n_);
                  I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
                  p_RM0_ = mccPR(&RM0_);
                  if (mccM(&dfddc) == 1) { I_dfddc = J_dfddc = 0;}
                  else { I_dfddc = 1; J_dfddc=mccM(&dfddc)-m_; }
                  p_dfddc = mccPR(&dfddc) + 0 + mccM(&dfddc) * (i-1);
                  if (mccM(&dcell) == 1) { I_dcell = J_dcell = 0;}
                  else { I_dcell = 1; J_dcell=mccM(&dcell)-m_; }
                  p_dcell = mccPR(&dcell) + 0 + mccM(&dcell) * (j-1);
                  if (m_ != 0)
                  {
                     for (j_=0; j_<n_; ++j_, p_dfddc += J_dfddc, p_dcell += J_dcell)
                     {
                        for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_dfddc+=I_dfddc, p_dcell+=I_dcell)
                        {
                           *p_RM0_ = (*p_dfddc * (double) *p_dcell);
                        }
                     }
                  }
               }
               mccSTRING(&RM0_) = 0;
               mccReshape(&RM1_, &RM0_, ((int)ndim), imcnt);
               mccSum(&dsplftdd, &RM1_);
               /* H(j+(i-1)*cnum)=2*(sum(dsplftd)+dsplftdd*e) ; */
               mccSum(&RM1_, &dsplftd);
               R0_ = (mccPR(&RM1_)[(1-1)]);
               R1_ = mccRealInnerProduct(&dsplftdd, &e);
               mccPR(&H)[((int)((j + ((i - 1) * (double) cnum))-.5))] = (2 * (double) (R0_ + R1_));
               /* H(i+(j-1)*cnum)=H(j+(i-1)*cnum) ; */
               mccPR(&H)[((int)((i + ((j - 1) * (double) cnum))-.5))] = (mccPR(&H)[((int)((j + ((i - 1) * (double) cnum))-.5))]);
               /* end ; */
            }
            /* end ; % end j */
         }
         /* end ; % end i */
      }
      mccReturnFirstValue(&plhs_[0], &gr);
      mccReturnValue(&plhs_[1], &H);
   }
   return;
}
