% Create demonstration images for regposter.tex
%
% Jan Kybic
% $Id: regposterwarp.m,v 1.1 2000/01/05 16:19:35 jkybic Exp $

function regposterwarp()

imdir='/home/jkybic/tex/imagesps/' ;
anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
affix='.ima' ;
anatname=[ anatpref num2str(10+anatofs) affix ] ;

path('/home/jkybic/matlab',path) ;
startupmatlab

% Demonstrate warping

anat=normalize(loadima(anatname)) ; 
figure(1) ;
imagesc(anat) ; colormap(gray) ;
axis image ; axis off ;
print('-deps', [ imdir 'regpostersrcimg.eps']) ;
[ny,nx]=size(anat) ;

% x and y coefficients of the deformation
% c is vertical, d horizontal
%c=[-1.6 -1.5 0.6 0.7 1 1.1;  -1 -0.5  0.6 0.8 1 1.1;  -1 0 0.5 0.8 1.2 2;  ...
%   -1 0 0.5 0.8 1.2 2; -1 0 0.3 0.7 1 2 ; -1 0 0.3 0.7 1 2   ] ;
%d=[-1 0 0.2 0.7 1 2;  -1 0 0.2 0.7 1 2;  -1 0 0.45 0.7 1.5 2.5;  ...
%  -1 0 0.5 0.7 1.5 2 ;  -1 0 0.2 0.8 1 2 ; -1 0 0.7 0.8 1 2 ]' ;
c=[-1.6 -1.5 0.6 0.7 1 1.1;  -1 -0.5  0.6 0.8 1 1.1;  -1 0 0.5 0.8 1.2 2;  ...
   -1 0 0.5 0.8 1.2 2; -1 0 0.3 0.7 1 2 ; -1 0 0.3 0.7 1 2   ] ;
d=[-1 0 0.15 0.7 1 2;  -1 0 0.2 0.7 1 2;  0 0.1 0.25 0.7 1.5 2.5;  ...
  -1 0 0.35 0.7 1.5 2 ;  -1 0 0.4 0.8 1 2 ; -1 0 0.4 0.8 1 2 ]' ;

figure(2) ;
% B-spline transformation of the coefficients
c=imcbanal(c) ; c=imcbanal(c')' ;
d=imcbanal(d) ; d=imcbanal(d')' ;
[nd,nc]=size(c) ;
c=reshape(c,1,nc*nd)*nx ;
d=reshape(d,1,nc*nd)*ny ;
% B-spline transformation of the image
l=imcbanal(anat) ;
l=imcbanal(l')' ;
% Warping
ime=meximwarpdc(l,[c d],nc,nx,ny) ;
% ime(find(abs(ime)==0))=255 ;
ime=normalize(ime) ; 
imagesc(ime) ;axis equal ; axis off ; colormap(gray) ;
print('-deps', [ imdir 'regposterdstimg.eps']) ;

figure(3) ; clf ;
[wx,wy]=splnwarp22([c d],nc,nx,ny) ;
disptablewf(wx,wy) ; axis off ;
print('-deps', [ imdir 'regposterwfimg.eps']) ;

