% Show the contents of regcrit12.log

%tabm=load('regcrit12.log') ;  % Marquardt Levenberg
tabm=load('regcrit19.log') ;  % Marquardt Levenberg
%tabg=load('regcrit16.log') ; % gradient descent
tabg=load('regcrit20.log') ; % gradient descent
%tabs=load('regcrit17.log') ; % gradient descent, single level
tabc=load('regcrit18.log') ; % conjugated gradient, pyramid
nm=size(tabm,1) ;
ng=size(tabg,1) ;
ns=size(tabs,1) ;
nc=size(tabc,1) ;

% iron out wiggling
for i=2:102, tabm(i,2)=min(tabm(i,2),tabm(i-1,2)) ; end ;
for i=104:182, tabm(i,2)=min(tabm(i,2),tabm(i-1,2)) ; end ;
for i=184:nm, tabm(i,2)=min(tabm(i,2),tabm(i-1,2)) ; end ;

for i=2:3395, tabg(i,2)=min(tabg(i,2),tabg(i-1,2)) ; end ;
for i=3397:6019, tabg(i,2)=min(tabg(i,2),tabg(i-1,2)) ; end ;
for i=6021:ng, tabg(i,2)=min(tabg(i,2),tabg(i-1,2)) ; end ;

for i=2:6000, tabc(i,2)=min(tabc(i,2),tabc(i-1,2)) ; end ;

% rescale for per pixel contribution
tabm(1:102,2)=tabm(1:102,2)*64 ;
tabm(103:182,2)=tabm(103:182,2)*8 ;
tabg(1:3395,2)=tabg(1:3395,2)*64 ;
tabg(3396:5019,2)=tabg(3396:5019,2)*8 ;
tabc(1:6000,2)=tabc(1:6000,2)*2 ; % this is a hack, to redo properly!!!


figure(1) ; clf ;
%plot(1:nm,tabm(:,2),1:ng,tabg(:,2),1:ns,tabs(:,2),...
%1:nc,tabc(:,2)) ; 
plot(1:nm,tabm(:,2),'-',1:ng,tabg(:,2),'--',1:nc,tabc(:,2),'-.') ; 

xlabel('iteration') ; ylabel('criterion') ;
legend('ML','GD','CG') ;
%title('Criterion evolution') ;
figure(2) ; clf ;
tabm(:,1)=tabm(:,1)-tabm(1,1) ;
tabg(:,1)=tabg(:,1)-tabg(1,1) ;
tabs(:,1)=tabs(:,1)-tabs(1,1) ;
tabc(:,1)=tabc(:,1)-tabc(1,1) ;

plot(tabm(:,1),tabm(:,2),'-',tabg(:,1),tabg(:,2),'--',tabc(:,1),tabc(:,2),'-.') ; 
xlabel('time [s]') ; ylabel('criterion') ;
legend('ML','GD','CG') ;
axis([0 5000 0 2e5]) ;
print -deps '/home/jkybic/tex/icip2000/showregepafig2.eps'
figure(1) ;
axis([0 250 0 2e5]) ;
print -deps '/home/jkybic/tex/icip2000/showregepafig1.eps'

