function [y,binc,shift]=evalbspline(x,n)
% Evaluate B-spline of degree n at points x (n=0 Haar, n=1 linear,...)
%
% Jan Kybic, Feb 2000
%
% $Id: evalbspline.m,v 1.2 2000/03/28 09:31:50 jkybic Exp $

N=length(x) ;
y=zeros(1,N) ;

binc=zeros(1,n+2) ;
shift=zeros(1,n+2) ;
for k=0:n+1,
  binc(k+1)=nchoosek(n+1,k)*(-1)^k/factorial(n) ;
  shift(k+1)=k-(n+1)/2 ;
end ;

for k=1:N,
  y(k)=bsplinept(x(k),n,binc,shift) ;
end ;

function y=bsplinept(x,n,binc,shift) ;
y=0 ;
if abs(x)<(n+1)/2,
  for k=1:n+2,
    if x>shift(k), y=y+binc(k)*(x-shift(k))^n ; end ;
  end ;
end ;