/*
 * MATLAB Compiler: 2.0
 * Date: Thu Nov 18 14:06:17 1999
 * Arguments: "-x" "filfirs.m" 
 */
#include "filfirs.h"

/*
 * The function "Mfilfirs" is the implementation version of the "filfirs"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/filfirs.m" (lines
 * 1-38). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function y=filfirs(x,w)
 */
static mxArray * Mfilfirs(int nargout_, mxArray * x, mxArray * w) {
    mxArray * y = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mclForLoopIterator iterator_1;
    mxArray * k = mclGetUninitializedArray();
    mxArray * k1 = mclGetUninitializedArray();
    mxArray * k2 = mclGetUninitializedArray();
    mxArray * np = mclGetUninitializedArray();
    mxArray * nw = mclGetUninitializedArray();
    mxArray * nx = mclGetUninitializedArray();
    mxArray * nx2 = mclGetUninitializedArray();
    mclValidateInputs("filfirs", 2, &x, &w);
    /*
     * %
     * % M. Unser / BEIP		Jan-93
     * %
     * % For symmetric filter only!
     * % First coeff = center;
     * 
     * nx=length(x);            %length of signal
     */
    mlfAssign(&nx, mlfLength(x));
    /*
     * np=2*nx-1;
     */
    mlfAssign(&np, mlfMinus(mlfMtimes(mlfScalar(2.0), nx), mlfScalar(1.0)));
    /*
     * nx2=2*nx;
     */
    mlfAssign(&nx2, mlfMtimes(mlfScalar(2.0), nx));
    /*
     * if nx==0
     */
    if (mlfTobool(mlfEq(nx, mlfScalar(0.0)))) {
        /*
         * error('Signal length is zero in routine filfirs')
         */
        mlfError(mxCreateString("Signal length is zero in routine filfirs"));
        /*
         * return
         */
        goto return_;
    /*
     * end
     */
    }
    /*
     * nw=length(w);             %length of filter
     */
    mlfAssign(&nw, mlfLength(w));
    /*
     * if nw==0
     */
    if (mlfTobool(mlfEq(nw, mlfScalar(0.0)))) {
        /*
         * error('Filter length is zero in routine filfirs')
         */
        mlfError(mxCreateString("Filter length is zero in routine filfirs"));
        /*
         * return
         */
        goto return_;
    /*
     * end
     */
    }
    /*
     * 
     * y=w(1)*x;
     */
    mlfAssign(&y, mlfMtimes(mlfIndexRef(w, "(?)", mlfScalar(1.0)), x));
    /*
     * for k=1:nx
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), nx, NULL);
         mclForNext(&iterator_0, &k);
         ) {
        /*
         * % y(k)=w(1)*x(k);																			
         * for i=1:nw-1
         */
        for (mclForStart(
               &iterator_1, mlfScalar(1.0), mlfMinus(nw, mlfScalar(1.0)), NULL);
             mclForNext(&iterator_1, &i);
             ) {
            /*
             * k1=k-i;
             */
            mlfAssign(&k1, mlfMinus(k, i));
            /*
             * k2=k+i;         
             */
            mlfAssign(&k2, mlfPlus(k, i));
            /*
             * if (k1<1)
             */
            if (mlfTobool(mlfLt(k1, mlfScalar(1.0)))) {
                /*
                 * k1=rem((1-k1),np)+1;
                 */
                mlfAssign(
                  &k1,
                  mlfPlus(
                    mlfRem(mlfMinus(mlfScalar(1.0), k1), np), mlfScalar(1.0)));
                /*
                 * if (k1>nx) k1=nx2-k1; end
                 */
                if (mlfTobool(mlfGt(k1, nx))) {
                    mlfAssign(&k1, mlfMinus(nx2, k1));
                }
            /*
             * end  
             */
            }
            /*
             * if (k2>nx)
             */
            if (mlfTobool(mlfGt(k2, nx))) {
                /*
                 * k2=rem((k2-1),np)+1;
                 */
                mlfAssign(
                  &k2,
                  mlfPlus(
                    mlfRem(mlfMinus(k2, mlfScalar(1.0)), np), mlfScalar(1.0)));
                /*
                 * if (k2>nx) k2=nx2-k2; end
                 */
                if (mlfTobool(mlfGt(k2, nx))) {
                    mlfAssign(&k2, mlfMinus(nx2, k2));
                }
            /*
             * end
             */
            }
            /*
             * y(k)=y(k)+(x(k1)+x(k2))*w(i+1);
             */
            mlfIndexAssign(
              &y,
              "(?)",
              k,
              mlfPlus(
                mlfIndexRef(y, "(?)", k),
                mlfMtimes(
                  mlfPlus(mlfIndexRef(x, "(?)", k1), mlfIndexRef(x, "(?)", k2)),
                  mlfIndexRef(w, "(?)", mlfPlus(i, mlfScalar(1.0))))));
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    return_:
    mclValidateOutputs("filfirs", 1, nargout_, &y);
    mxDestroyArray(i);
    mxDestroyArray(k);
    mxDestroyArray(k1);
    mxDestroyArray(k2);
    mxDestroyArray(np);
    mxDestroyArray(nw);
    mxDestroyArray(nx);
    mxDestroyArray(nx2);
    return y;
}

/*
 * The function "mlfFilfirs" contains the normal interface for the "filfirs"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/filfirs.m" (lines
 * 1-38). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfFilfirs(mxArray * x, mxArray * w) {
    int nargout = 1;
    mxArray * y = mclGetUninitializedArray();
    mlfEnterNewContext(0, 2, x, w);
    y = Mfilfirs(nargout, x, w);
    mlfRestorePreviousContext(0, 2, x, w);
    return mlfReturnValue(y);
}

/*
 * The function "mlxFilfirs" contains the feval interface for the "filfirs"
 * M-function from file "/home/jkybic/work/matlabsrc/spline/filfirs.m" (lines
 * 1-38). The feval function calls the implementation version of filfirs
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxFilfirs(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: filfirs Line: 1 Column: "
            "0 The function \"filfirs\" was called with mor"
            "e than the declared number of outputs (1)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: filfirs Line: 1 Column:"
            " 0 The function \"filfirs\" was called with m"
            "ore than the declared number of inputs (2)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mfilfirs(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}
