function c=firfiltm(x,f) ;
% Returns a convolution of x with a tensor product of symetrized f
% Applies filfirs along all dimensions of a multidimensional array
% Mirror boundary conditions
%
% Usage: c=filfirs(x,f) ;
%
% $Id: firfiltm.m,v 1.2 1999/11/18 21:04:33 jkybic Exp $
% Jan Kybic, 1999

N=ndims(x) ;

s=size(x) ;

if N==2 & ( s(1)==1 | s(2)==1 ), % unidimensional x
  N=1 ;
end ;

switch N
  case 1,
    c=filfirs(x,f) ;
  case 2,
    for i=1:s(1),
      c(i,:)=filfirs(x(i,:),f) ;
    end ;
    for i=1:s(2),
      c(:,i)=filfirs(c(:,i),f) ;
    end ;
  case 3,
    for i1=1:s(1),
      for i2=1:s(2),
	c(i1,i2,:)=filfirs(squeeze(x(i1,i2,:)),f) ;
      end ;
    end ;
    for i1=1:s(1),
      for i2=1:s(3),
	c(i1,:,i2)=filfirs(squeeze(c(i1,:,i2)),f) ;
      end ;
    end ;
    for i1=1:s(2),
      for i2=1:s(3),
	c(:,i1,i2)=filfirs(squeeze(c(:,i1,i2)),f) ;
      end ;
    end ;
  otherwise,
    error('Sorry, dimensionality of x is not supported, probably too high') ;
end ;    
    