function c=fsplinem(x,order) ;
% Returns B-spline coefficients of a multidimensional array
% Applies fspline along all dimensions of a multidimensional array
% Mirror boundary conditions
%
% Usage: c=fsplinem(x,order) ;
%
% $Id: fsplinem.m,v 1.2 1999/09/10 20:05:21 jkybic Exp $
% Jan Kybic, 1999

N=ndims(x) ;

s=size(x) ;

if N==2 & ( s(1)==1 | s(2)==1 ), % unidimensional x
  N=1 ;
end ;

switch N
  case 1,
    c=fspline(x,order) ;
  case 2,
    for i=1:s(1),
      c(i,:)=fspline(x(i,:),order) ;
    end ;
    for i=1:s(2),
      c(:,i)=fspline(c(:,i),order) ;
    end ;
  case 3,
    for i1=1:s(1),
      for i2=1:s(2),
	c(i1,i2,:)=fspline(x(i1,i2,:),order) ;
      end ;
    end ;
    for i1=1:s(1),
      for i2=1:s(3),
	c(i1,:,i2)=fspline(c(i1,:,i2),order) ;
      end ;
    end ;
    for i1=1:s(2),
      for i2=1:s(3),
	c(:,i1,i2)=fspline(c(:,i1,i2),order) ;
      end ;
    end ;
  otherwise,
    error('Sorry, dimensionality of x is not supported, probably too high') ;
end ;    
    