function [gr,H]=privsdcgr(e,dcell,ftd,ftdd,cnum,ndim,imcnt)
% Private executable part of sdcgr, just so that it is compilable
%
% $Id: privsdcgr.m,v 1.4 1999/11/20 20:42:13 jkybic Exp $
% Jan Kybic, 1999
%
% compiled with 'mcc -V1.2 -irv privsdcg' slows it down!!!  
% I originally separated this part from sdcgr so that I can compile it
% but now I see it is not worth it. Strange.

H=zeros(cnum,cnum) ; % the future Hessian matrix
gr=zeros(cnum,1) ;

dfc=zeros(imcnt*ndim,cnum) ;
dfddc=zeros(imcnt*ndim,cnum) ;
for i=1:cnum, % for all parameters c
  dfc(:,i)=dcell(:,i).*ftd ;
  dfddc(:,i)=dcell(:,i).*ftdd ;
  if ndim==1,
    gr(i)=2*sum(e.*dfc(:,i)) ;
  else
    dsplftd=sum(reshape(dfc(:,i),ndim,imcnt)) ;
    gr(i)=2*(dsplftd*e) ; % scalar product
  end ;
  % Here we start with the Hessian calculation
  for j=1:i,
    if ndim==1,
      H(j+(i-1)*cnum)=2*sum(dcell(:,i).*dcell(:,j).*(ftd.^2+e.*ftdd)) ;
      H(i+(j-1)*cnum)=H(j+(i-1)*cnum) ;
    else
      dsplftd=sum(reshape(dfc(:,i).*dfc(:,j),ndim,imcnt)) ;
      dsplftdd=sum(reshape(dfddc(:,i).*dcell(:,j),ndim,imcnt)) ;
      H(j+(i-1)*cnum)=2*(sum(dsplftd)+dsplftdd*e) ;
      H(i+(j-1)*cnum)=H(j+(i-1)*cnum) ;
    end ;
  end ; % end j
end ; % end i
