function showbasfsupp ;
% Show the support (spatial extent) of several basis function sets
% for the Fast El. Reg. chapter of my thesis
%
% Jan Kybic, May 2001
% $Id: showbasfsupp.m,v 1.1 2001/05/23 13:58:36 jkybic Exp $

x0=19.3  ;      % where we calculate
xmax=40 ;
x=0:0.1:xmax ; % all points
nx=length(x) ;
knots=0:3:xmax ;
nknots=length(knots) ;

figure(1) ; clf ;
% x^3 basis
y=zeros(nknots,nx) ;
for i=1:nknots,
  y(i,:)=abs(x-knots(i)).^3 ;
end ;

h=plot(x,y,'k-',[x0 x0],[0 10],'k-') ;
%h=findobj(gca,'Type','line','Marker','o')
nh=length(h) ;
set(h(nh),'LineWidth',4) ;
axis([0 xmax 0 10]) ; axis off
print -deps showbasfsuppx3.eps

figure(2) ; clf
% harmonic basis
nharm=8 ;
y=zeros(nharm*2,nx) ;
% y(1,:)=ones(1,nx) ;
for i=1:nharm,
  y(2*i-1,:)=sin(2*pi*i*x/xmax)-3*i ;
  y(2*i,:)=cos(2*pi*i*x/xmax)-3*i ;
end ;

h=plot(x,y,'k-',[x0 x0],[0 -3*nharm-1],'k-') ;
%h=findobj(gca,'Type','line','Marker','o')
nh=length(h) ;
set(h(nh),'LineWidth',4) ;
axis off
%axis([0 xmax -1 1]) ;
print -deps showbasfsuppharm.eps

% splines
figure(3) ; clf
y=zeros(4,nx) ;
for i=1:4,
  y(i,:)=evalbspline(x-floor(x0)-i+2,3) ;
end ;

h=plot(x,y,'k-',[x0 x0],[0 0.7],'k-') ;
nh=length(h) ;
set(h(nh),'LineWidth',4) ;
axis off
print -deps showbasfsuppspln.eps

% wavelets
figure(4) ; clf ; 
pstruct=load('psicubic') ; psi=real(pstruct.psi) ; % load wavelet
psix=pstruct.x ;
y=zeros(0,nx) ;
for i=0:3, % scale
  for j=-4:2:2, % position
    yw=interp1(psix,psi,(x-floor(x0))/2^i-j)-(i-1)*0.5 ;
    y=[y ; yw] ;
  end ;
end ;

h=plot(x,y,'k-',[x0 x0],[-1.3 0.8],'k-') ;
nh=length(h) ;
set(h(nh),'LineWidth',4) ;
axis([0 xmax -1.3 0.8]) ; axis off
print -deps showbasfsuppwav.eps
