function showlocalxthr ;
% Show the localization of |x|^3 basis functions
% and the r^2*log r radial basis functions
%
% Jan Kybic, March 2001
% $Id: showlocalxthr.m,v 1.5 2001/03/18 14:56:55 jkybic Exp $ 

xpts=[ -2 -1 0 1 2 ] ;
nx=length(xpts) ;
t=-3:0.1:3 ;
nt=length(t) ;
y=zeros(nt,nx) ;


for i=1:nx,
  y(:,i)=abs(t'-xpts(i)).^3 ;
end ;

figure(1) ;
subplot(211) ; plot(t,y) ;  axis([-3 3 0 5]) ; grid on

yl=zeros(nt,nx) ;


for i=1:nx,
  yl(:,i)=evloc(t'-xpts(i));
end ;

subplot(212) ; plot(t,yl) ;  axis([-3 3 0 0.7]) ; grid on

print -deps showlocalxthr.eps

%%% Now the RBF

figure(2) ;
[X,Y]=meshgrid(-2:.1:2,-2:.1:2) ;
R1=(X.^2+Y.^2) ;
F1=R1.*log(R1)/2 ;
F1(find(isnan(F1)))=0 ;
mesh(X,Y,F1)
print -deps showrlogrrbf.eps


figure(3)
Z=X*0;
%fil=[1 -2 1] ;
fil=[1 -4 6 -4 1] ;
for ix=-2:2,
  for iy=-2:2,
    R1=((X-ix).^2+(Y-iy).^2) ;
    F1=R1.*log(R1)/2 ;
    F1(find(isnan(F1)))=0 ;
    Z=Z+fil(ix+3)*fil(iy+3)*F1 ;
  end ;
end ;

mesh(X,Y,Z)
print -deps showlocalrbf.eps

function z=evloc(x); 
% evaluates the localized basis function
h=[ 1 -4 +6 -4 1] ;
ofs=(length(h)+1)/2 ;
z=x*0 ;
for i=1:length(h),
  z=z+h(i)*abs(x-(i-ofs)).^3 ;
end ;
z=z/12 ;
 
