% Test interpolation by mexsplninterp
%
% $Id: trymexsplninterp.m,v 1.2 2000/01/31 16:24:40 jkybic Exp $
% Jan Kybic, 1999

%%%%% 1D 
if 1,
figure(1) ; title('1D test') ;
y=[ 10 5 4 3 3 6 8 2 1 10 ]' ;
% y=[ 10 11  ]' ;
N=length(y) ;
t=0:0.1:N-1 ;
%t=0:N-1 ;

c0=fsplinem(y,0) ;
y0=mexsplninterp(c0,t,1,0) ;
c1=fsplinem(y,1) ;
y1=mexsplninterp(c1,t,1,1) ;
c2=fsplinem(y,2) ;
y2=mexsplninterp(c2,t,1,2) ;
c3=fsplinem(y,3) ;
y3=mexsplninterp(c3,t,1,3) ;

plot(t,y0,t,y1,t,y2,t,y3) ;
%plot(t,y0,t,y1,t,y2) ;
legend('0','1','2','3') ;
end ;

%%%%%%%%% 2D test
if 0,
figure(2) ; title('2D test') ;
img=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
subplot(221) ; imagesc(img) ; colormap(pink) ; axis image ;
[ny,nx]=size(img) ;
tt=zeros(2,ny,nx) ;
for ix=1:nx, 
  tt(:,:,ix)=[ (1:ny)-1 ; ix*ones(1,ny)-1 ] ;
end ;
cc=cputime ;
i2=fsplinem(img,2) ;
disp(['Analyze takes ' num2str(cputime-cc) ]) ;
cc=cputime ;
b2=mexsplninterp(i2,tt,2,2) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(222) ; imagesc(b2) ; colormap(pink) ; axis image ;
cc=cputime ;
i2=fsplinem(img,3) ;
disp(['Analyze takes ' num2str(cputime-cc) ]) ;
cc=cputime ;
b2=mexsplninterp(i2,tt,2,3) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(223) ; imagesc(b2) ; colormap(pink) ; axis image ;
cc=cputime ;
b2=mexsplninterp(img,tt,2,1) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(224) ; imagesc(b2) ; colormap(pink) ; axis image ;
end
%%%%%%%% 3D test
if 0,
figure(3) ;title('3D test') ;
img1=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
img2=double(imread('/home/jkybic/people/philippe/reg/einstein.TIFF')) ;
[ny,nx]=size(img1) ;
img=zeros(ny,nx,2) ;
img(:,:,1)=double(img1) ; img(:,:,2)=double(img2) ;
cc=cputime ;
imgc=fsplinem(img,3) ;
disp(['Analyze takes ' num2str(cputime-cc) ]) ;
for q=0:3,
  tt3=zeros(3,ny,nx) ;
  for ix=1:nx, 
    tt3(:,:,ix)=[ (1:ny)-1 ; ix*ones(1,ny)-1 ; q/3*ones(1,ny) ] ;
  end ;
  disp('table generated') ;
  subplot(2,2,q+1) ;cc=cputime ;
  imgi=mexsplninterp(imgc,tt3,3,3) ;
  disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
  imagesc(imgi) ; colormap pink ; axis image ;
  disp('Press any key') ;
  pause ;
end ;
end ;
%%%%% Derivatives
if 0,
figure(4) ; title('Derivatives') ;
img=double(imread('/home/jkybic/people/philippe/reg/barb.TIFF')) ;
subplot(221) ; imagesc(img) ; colormap(pink) ; axis image ;
[ny,nx]=size(img) ;
tt=zeros(2,ny,nx) ;
for ix=1:nx, 
  tt(:,:,ix)=[ (1:ny)-1 ; ix*ones(1,ny)-1 ] ;
end ;
cc=cputime ;
i2=fsplinem(img,2) ;
disp(['Analyze takes ' num2str(cputime-cc) ]) ;
cc=cputime ;
b2=mexsplninterp(i2,tt,2,2,1) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(221) ; imagesc(b2) ; colormap(pink) ; axis image ;
cc=cputime ;
b2=mexsplninterp(i2,tt,2,2,4) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(222) ; imagesc(b2) ; colormap(pink) ; axis image ;
cc=cputime ;
i2=fsplinem(img,3) ;
disp(['Analyze takes ' num2str(cputime-cc) ]) ;
cc=cputime ;
b2=mexsplninterp(i2,tt,2,3,1) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(223) ; imagesc(b2) ; colormap(pink) ; axis image ;
b2=mexsplninterp(i2,tt,2,3,4) ;
disp(['Interpolation takes ' num2str(cputime-cc) ]) ;
subplot(224) ; imagesc(b2) ; colormap(pink) ; axis image ;
end
