function y=conv_sino3(sinogr,filter,d)
% Y=CONV_SINO3(SINOGR,FILTER,D)  filter sinogram
%
% INPUT ARGS:
%               sinogr - the sinogram
%               filter - either the string specifying the filter 
%               d      - the fraction of frequencies below the nyquist
%                        which we want to pass
%
% OUTPUT ARGS:         - the filtered sinogram
%
% See also: create_filter

error(nargchk(1,3,nargin))

if(nargin<2) filter=1; end  % Standard filter is ramlak
if(nargin<3) d=1; end;       % Standard value for d=1;

p=sinogr';
len=size(p,1);   
H = create_filter(filter, len, d);
p(length(H),1)=0;  % Zero pad projections 

p = fft(p);    % p holds fft of projections

for i = 1:size(p,2)
  p(:,i) = p(:,i).*H; % frequency domain filtering
end
p = real(ifft(p));     % p is the filtered projections
p(len+1:end,:) = [];   % Truncate the filtered projections
y=p';


