function y=gensphere(sz) ;
% gensphere generates a 3D volume with a sphere in the middle
% `sz' is a 3 component vector with the desired size of the
% output image s
%
% Usage: s=gensphere(sz)
%
% $Id: gensphere.m,v 1.2 1999/11/18 10:00:54 jkybic Exp $
% Jan Kybic, 1999

sz=sz(:) ;
r=(0.7*min(sz)/2)^2 ;
[f1,f2,f3]=ndgrid(1:sz(1),1:sz(2),1:sz(3)) ;
y=zeros(sz') ;
dist=(f1-(sz(1)+1)/2).^2+(f2-(sz(2)+1)/2).^2+(f3-(sz(3)+1)/2).^2 ;
y(ind2sub(size(dist),find(dist<r)))=1 ;
