function y=readhdf(fn,ds)
% Reads a file 'fn' in the HDF4 format and stores the dataset 'ds' into y
%
%
% Philippe's HDF files converted as:
% y=readhdf('v0.hdf')
% fid=fopen('philippe-v0-45x512x512-int16.raw','wb') ; % Matlab size
% fwrite(fid,y,'integer*2') ;
% fclose(fid) ;
%
% And read in Python as:
%
% m=regultrasound.readRawMatlabInts(
%            'data_felreg/philippe-v0-45x512x512-int16.raw',(45,512,512))
%
% $Id: readhdf.m,v 1.2 2001/06/10 14:10:01 jkybic Exp $

if nargin<2,
  ds=0
end ;


sd_id = hdfsd('start',fn,'read');

[ndatasets, nglobal_atts, stat] = hdfsd('fileinfo',sd_id)

for i=1:nglobal_atts,
  hdfsd('readattr',sd_id,i)
end ;
sds_id = hdfsd('select',sd_id,ds)
[dsname, dsndims, dsdims, dstype, dsatts, stat] = hdfsd('getinfo',sds_id)

dsstart = zeros(1,dsndims); % Creates the vector [0 0]
dsstride = []; 
dsedges = dsdims; 

[y, status] = hdfsd('readdata',sds_id,dsstart,dsstride,dsedges) ;