function vol=readnema(filename,sz)
% Reads a NEMA file containing a volume, 4B float per pixel
% sz is a 3 element vector containing the expected size
% header length is calculated automatically
%
% $Id: readnema.m,v 1.1 1999/11/19 19:01:56 jkybic Exp $
% Jan Kybic, 1999

f=fopen(filename,'r') ;
if f<0, error([ 'Could not open file ''' filename '''.' ]) ; end ;

fseek(f,0,1) ;
len=ftell(f)-prod(sz)*4 ; % 4 bytes per pixel
fseek(f,len,-1) ; % skip the header
[vol,cnt]=fread(f,inf,'float32') ;
if cnt~=prod(sz),
  error(['Read ' num2str(cnt) ' bytes instead of ' num2str(prod(sz)) ]) ;
end ;

vol=reshape(vol,sz) ;
fclose(f) ;