% This script takes the A,C subject data and makes the registration

clear all
ecdA=readnema('/home/jkybic/uge/sujet-A_TRA_OM-r199907091706.nema',[128 128 35]) ;
ecdA=ecdA(:,:,1:34) ;

ecdC=readnema('/home/jkybic/uge/sujet-C_TRA_OM-r199907091558.nema',[128 128 35]) ;

ecdC=ecdC(:,:,1:34) ;

ecdC=L2pyramid_down(ecdC,3,'card','bspln') ;
ecdA=L2pyramid_down(ecdA,3,'card','bspln') ;
% register
c0=zeros(3,4,4,4) ; alpha=1e-3 ; degc=2 ; degft=3 ;
disp('Starting registration') ;
cc=cputime ;
c1=regoptpyr(ecdA,ecdC,c0,alpha,3) ;
disp([ 'Registration took ' num2str(cputime-cc) ' s']) ;
%save ecdACreg3 c1
%load ecdACreg2
ecdCc=fsplinem(ecdC,degft) ;
imsize=size(ecdC) ;
tbl=deftable(c1,imsize,degc) ;
ecdCd=mexsplninterp(ecdCc,tbl,3,degft) ;
subplot(411) ; imagesc([ ecdA(:,:,10) ecdC(:,:,10)]) ;
title('reference/test') ; colormap(pink) ;
subplot(412) ; imagesc([ ecdA(:,:,10)-ecdC(:,:,10) ecdA(:,:,10)-ecdCd(:,:,10)]) ;
colorbar ; title('before/after') ; 

% Read the EP images
epA=readnema('/home/jkybic/uge/sujet-A_EP-r199907091642.nema',[64 64 18]) ;
epA=epA(:,:,1:17) ;
epC=readnema('/home/jkybic/uge/sujet-C_EP-r199907091534.nema',[64 64 17]) ;
epC=epC(:,:,1:17) ;
epCc=fsplinem(epC,3) ;
tblep=deftable(c1,size(epA),degc) ; % EP is half the size of ECD
epCd=mexsplninterp(epCc,tblep,3,degft) ;
subplot(413) ; imagesc([ epC(:,:,10) epCd(:,:,10)]) ; 
title('EP image/warped') ;
subplot(414) ; imagesc([ epC(:,:,10)-epA(:,:,10) epCd(:,:,10)-epA(:,:,10)]) ; 
title('EP dif before/after') ; colorbar ;

