function [c,E]=regopt(fr,ft,c0,alpha)
% Optimizes registration criterion
% fr - registration image, ft - test image (to be warped), 
% c0 - starting guess, alpha - regularization
%
% Usage: [c,E]=regopt(fr,ft,c0,alpha)
% Jan Kybic, 1999
% $Id: regopt.m,v 1.19 2001/06/05 15:11:04 jkybic Exp $

csize=size(c0) ;
par.fr=fr ; par.alpha=alpha ; par.csize=csize ;
par.degree=2 ; par.degim=3 ;

par.ftc=fsplinem(ft,par.degim) ;

c=reshape(c0,prod(csize),1) ;
% c=graddesc('regcrit',c,par) ;
%c=conjgrad('regcrit',c,par) ;
c=marqlev('regcrit',c,par) ; % this needs regcrit to return a Hessian too
c=reshape(c,csize) ;
E=regcrit(c,par) 