function [c,E]=regoptpyr(fr,ft,c0,alpha,levels,minlevel)
% Image multiresolution for regopt
% fr - registration image, ft - test image (to be warped), 
% c0 - starting guess, alpha - regularization
% levels - number of levels
%
% Usage: [c,E]=regoptpyr(fr,ft,c0,alpha,levels)
% Jan Kybic, 1999
% $Id: regoptpyr.m,v 1.5 2001/06/05 15:11:04 jkybic Exp $

frp=pyramid2(fr,levels,'cardinal') ;
ftp=pyramid2(ft,levels,'cardinal') ;
global evalfinecritE evalfineimsize 
global evalfineitercnt evalfinelsti
evalfineitercnt=0 ;
evalfinelsti=0 ;

if nargin<6,    % Minimum level
  minlevel=1
end ;

c=c0 ;
disp([ 'regoptpyr started with E=' num2str(sum(sum(sum((fr-ft).^2)))) ]) ;

for i=levels:-1:minlevel,
  c=2*c ; % update c
  evalfineimsize=size(frp{i}) ;
  evalfinecritE=1e100 ;
  [c,E]=regopt(frp{i},ftp{i},c,alpha) ;
  disp([ 'regoptpyr level ' num2str(i) ' finished with E=' num2str(E) ]) ;
end ;
  